<?php
// $Id: pnadmin.php,v 1.4 2003/05/15 09:54:55 bravecobra Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program (PostNuke) is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Module: ContentExpress
// Copyright (C) 2002 by the Content Express Development Team.
//                           Arising Group, Inc.
// http://xexpress.sourceforge.net/
// Original Author of file: Chester Chee
// Purpose of file:  ContentExpress administration display functions
// ----------------------------------------------------------------------

$ModName = basename( dirname( __FILE__ ) );

include_once( "modules/$ModName/pnclass/CommonExpress.php" );
include_once( "modules/$ModName/pneditor/pnCEHTML.php" );
include_once( "modules/$ModName/pnclass/Category.php" );
include_once( "modules/$ModName/pnclass/ContentExpress.php" );
include_once( "modules/$ModName/pnclass/MediaExpress.php" );
include_once( "modules/$ModName/pnclass/MenuExpress.php" );


/**
 * the main administration function
 * This function is the default function, and is called whenever the
 * module is initiated without defining arguments.  As such it can
 * be used for a number of things, but most commonly it either just
 * shows the module menu and returns or calls whatever the module
 * designer feels should be the default function (often this is the
 * view() function)
 */
function ContentExpress_admin_main()
{
    // Create output object - this object will store all of our output so that
    // we can return it easily when required
    $output = new pnHTML();

    // Security check - important to do this as early as possible to avoid
    // potential security holes or just too much wasted processing.  For the
    // main function we want to check that the user has at least edit privilege
    // for some item within this component, or else they won't be able to do
    // anything and so we refuse access altogether.  The lowest level of access
    // for administration depends on the particular module, but it is generally
    // either 'edit' or 'delete'
    if (!pnSecAuthAction(0, 'ContentExpress::', '::', ACCESS_EDIT)) {
        $output->Text(_MENUCONTENTNOAUTH);
        return $output->GetOutput();
    }

    // Add menu to output - it helps if all of the module pages have a standard
    // menu at their head to aid in navigation
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(pnModFunc('ContentExpress', 'admin', 'newcontent'));

    // Return the output that has been generated by this function
    return $output->GetOutput();
}

/**
 * Main administration menu
 */
function ContentExpress_admin_adminmenu()
{
    // Create output object - this object will store all of our output so that
    // we can return it easily when required
    $output = new pnHTML();

    // Display status message if any.  Note that in future this functionality
    // will probably be in the theme rather than in this menu, but this is the
    // best place to keep it for now
    $output->Text(pnGetStatusMsg());
    $output->Linebreak(2);

    // Start options menu
    $output->TableStart(_MENUCONTENT);
    $output->SetOutputMode(_PNH_RETURNOUTPUT);

    // Menu options.  These options are all added in a single row, to add
    // multiple rows of options the code below would just be repeated
    $viewcolumns = array();
    if (pnSecAuthAction(0, 'MenuExpress::Menu', '::', ACCESS_ADMIN)) {
        $viewcolumns[] = $output->URL(pnModURL('ContentExpress',
                                               'admin',
                                               'newmenu'),
                                      _MENUCONTENTVIEWMENUS); 
    }
    if (pnSecAuthAction(0, 'ContentExpress::Content', '::', ACCESS_ADMIN)) {
        $viewcolumns[] = $output->URL(pnModURL('ContentExpress',
                                               'admin',
                                               'newcontent'),
                                      _MENUCONTENTVIEWCONTENTS); 
        $viewcolumns[] = $output->URL(pnModURL('ContentExpress',
                                               'admin',
                                               'mediamanager'),
                                      _MENUCONTENTMEDIAMGR);
    }
    if (pnSecAuthAction(0, 'ContentExpress::Category', '::', ACCESS_ADMIN)) {
        $viewcolumns[] = $output->URL(pnModURL('ContentExpress',
                                               'admin',
                                               'newcategory'),
                                      _MENUCONTENTVIEWCATS); 
    }

    $admincolumns = array();
    if (pnSecAuthAction(0, 'MenuExpress::Menu', '::', ACCESS_ADMIN)) {
        $admincolumns[] = $output->URL(pnModURL('ContentExpress',
                                                'admin',
                                                'modifymeconfig'),
                                       _MENUCONTENTEDITMECONFIG); 
    }
    if (pnSecAuthAction(0, 'ContentExpress::Content', '::', ACCESS_ADMIN)) {
        $admincolumns[] = $output->URL(pnModURL('ContentExpress',
                                                'admin',
                                                'modifyceconfig'),
                                       _MENUCONTENTEDITCECONFIG); 
        $admincolumns[] = $output->URL(pnModURL('ContentExpress',
                                                'admin',
                                                'modifymmeconfig'),
                                       _MENUCONTENTEDITMMECONFIG); 
    }
    if (pnSecAuthAction(0, 'ContentExpress::Category', '::', ACCESS_ADMIN)) {
        $admincolumns[] = $output->Text( "" );
    }

    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($newcolumns);
    $output->TableAddRow($viewcolumns);
    $output->TableAddRow($admincolumns);
    $output->SetInputMode(_PNH_PARSEINPUT);

    $output->TableEnd();

    // Return the output that has been generated by this function
    return $output->GetOutput();
}

/**
 * add new content item
 * This is a standard function that is called whenever an administrator
 * wishes to create a new module content item
 */
function ContentExpress_admin_newcontent()
{
    $content = new ContentExpress();
    return $content->admin_new();
}

/**
 * add new category
 * This is a standard function that is called whenever an administrator
 * wishes to create a new module content item
 */
function ContentExpress_admin_newcategory()
{
    $category = new Category();
    return $category->admin_new();
}

/**
 * This is a standard function that is called with the results of the
 * form supplied by ContentExpress_admin_newcontent() to create a new content item
 * @param 'title' the title of the content item to be created
 * @param 'anchor' the anchor (url) of the content item to be created
 * @param 'parent_id' the parent of the content item to be created
 * @param 'language' the language of the content item to be created
 * @param 'weight' the weight of the content item to be created
 * @param 'active' the status of the content item to be created
 */
function ContentExpress_admin_createcontent($args)
{
    $content = new ContentExpress();
    return $content->admin_create( $args );
}

/**
 * This is a standard function that is called with the results of the
 * form supplied by ContentExpress_admin_newcategory() to create a new category
 * @param 'title' the title of the content item to be created
 * @param 'parent_id' the parent of the content item to be created
 * @param 'language' the language of the content item to be created
 * @param 'weight' the weight of the content item to be created
 * @param 'active' the status of the content item to be created
 */
function ContentExpress_admin_createcategory($args)
{
    $category = new Category();
    return $category->admin_create( $args );
}

/**
 * edit a content item
 * This is a standard function that is called whenever an administrator
 * wishes to edit a current module content item
 * @param 'ceid' the id of the content item to be modified
 */
function ContentExpress_admin_editcontent($args)
{
    $content = new ContentExpress();
    return $content->admin_edit($args);
}

/**
 * edit a category
 * This is a standard function that is called whenever an administrator
 * wishes to edit a current module category item
 * @param 'cecatid' the id of the content item to be modified
 */
function ContentExpress_admin_editcategory($args)
{
    $category = new Category();
    return $category->admin_edit($args);
}

/**
 * This is a standard function that is called with the results of the
 * form supplied by ContentExpress_admin_editcontent() to update a current item
 * @param 'tid' the id of the item to be updated
 * @param 'name' the name of the item to be updated
 * @param 'number' the number of the item to be updated
 */
function ContentExpress_admin_updatecontent($args)
{
    $content = new ContentExpress();
    return $content->admin_update( $args );
}

/**
 * This is a standard function that is called with the results of the
 * form supplied by ContentExpress_admin_editcategory() to update a current item
 * @param 'tid' the id of the item to be updated
 * @param 'name' the name of the item to be updated
 * @param 'number' the number of the item to be updated
 */
function ContentExpress_admin_updatecategory($args)
{
    $category = new Category();
    return $category->admin_update( $args );
}

/**
 * delete content item
 * This is a standard function that is called whenever an administrator
 * wishes to delete a current module item.  Note that this function is
 * the equivalent of both of the modify() and update() functions above as
 * it both creates a form and processes its output.  This is fine for
 * simpler functions, but for more complex operations such as creation and
 * modification it is generally easier to separate them into separate
 * functions.  There is no requirement in the PostNuke MDG to do one or the
 * other, so either or both can be used as seen appropriate by the module
 * developer
 * @param 'ceid' the id of the content item to be deleted
 * @param 'confirmation' confirmation that this content item can be deleted
 */
function ContentExpress_admin_delcontent($args)
{
    $content = new ContentExpress();
    return $content->admin_delete( $args );
}

/**
 * delete category
 * This is a standard function that is called whenever an administrator
 * wishes to delete a current module item.  Note that this function is
 * the equivalent of both of the modify() and update() functions above as
 * it both creates a form and processes its output.  This is fine for
 * simpler functions, but for more complex operations such as creation and
 * modification it is generally easier to separate them into separate
 * functions.  There is no requirement in the PostNuke MDG to do one or the
 * other, so either or both can be used as seen appropriate by the module
 * developer
 * @param 'ceid' the id of the content item to be deleted
 * @param 'confirmation' confirmation that this content item can be deleted
 */
function ContentExpress_admin_delcategory($args)
{
    $category = new Category();
    return $category->admin_delete( $args );
}

/**
 * This is a standard function that is called with the results of the
 * anchor supplied by ContentExpress_admin_viewcontents() to update a current content item
 * @param 'ceid' the id of the content item to be updated
 * @param 'pid' the parent id/previous ceid of the content item
 * @param 'task' the task to be performed on the content item
 */
function ContentExpress_admin_qupdcontent($args)
{
    $content = new ContentExpress();
    return $content->admin_qupdate( $args );
}

/**
 * This is a standard function that is called with the results of the
 * anchor supplied by ContentExpress_admin_viewcategories() to update a current content item
 * @param 'ceid' the id of the content item to be updated
 * @param 'pid' the parent id/previous ceid of the content item
 * @param 'task' the task to be performed on the content item
 */
function ContentExpress_admin_qupdcategory($args)
{
    $category = new Category();
    return $category->admin_qupdate( $args );
}

/**
 * add new menu item
 * This is a standard function that is called whenever an administrator
 * wishes to create a new module menu item
 */
function ContentExpress_admin_newmenu()
{
    $menu = new MenuExpress();
    return $menu->admin_new();
}

/**
 * This is a standard function that is called with the results of the
 * form supplied by ContentExpress_admin_newmenu() to create a new menu item
 * @param 'title' the title of the menu item to be created
 * @param 'anchor' the anchor (url) of the menu item to be created
 * @param 'parent_id' the parent of the menu item to be created
 * @param 'language' the language of the menu item to be created
 * @param 'weight' the weight of the menu item to be created
 * @param 'active' the status of the menu item to be created
 */
function ContentExpress_admin_createmenu($args)
{
    $menu = new MenuExpress();
    return $menu->admin_create( $args );
}

/**
 * edit an item
 * This is a standard function that is called whenever an administrator
 * wishes to edit a current module menu item
 * @param 'mid' the id of the menu item to be modified
 */
function ContentExpress_admin_editmenu($args)
{
    $menu = new MenuExpress();
    return $menu->admin_edit($args);
}


/**
 * This is a standard function that is called with the results of the
 * form supplied by ContentExpress_admin_editmenu() to update a current item
 * @param 'tid' the id of the item to be updated
 * @param 'name' the name of the item to be updated
 * @param 'number' the number of the item to be updated
 */
function ContentExpress_admin_updatemenu($args)
{
    $menu = new MenuExpress();
    return $menu->admin_update( $args );
}

/**
 * delete menu item
 * This is a standard function that is called whenever an administrator
 * wishes to delete a current module item.  Note that this function is
 * the equivalent of both of the modify() and update() functions above as
 * it both creates a form and processes its output.  This is fine for
 * simpler functions, but for more complex operations such as creation and
 * modification it is generally easier to separate them into separate
 * functions.  There is no requirement in the PostNuke MDG to do one or the
 * other, so either or both can be used as seen appropriate by the module
 * developer
 * @param 'mid' the id of the menu item to be deleted
 * @param 'confirmation' confirmation that this menu item can be deleted
 */
function ContentExpress_admin_delmenu($args)
{
    $menu = new MenuExpress();
    return $menu->admin_delete( $args );
}

/**
 * This is a standard function that is called with the results of the
 * anchor supplied by ContentExpress_admin_viewmenus() to update a current menu item
 * @param 'mid' the id of the menu item to be updated
 * @param 'pid' the parent id/previous mid of the menu item
 * @param 'task' the task to be performed on the menu item
 */
function ContentExpress_admin_qupdmenu($args)
{
    $menu = new MenuExpress();
    return $menu->admin_qupdate( $args );
}

/**
 * This is a standard function to modify the configuration parameters of the
 * module
 */
function ContentExpress_admin_modifyceconfig()
{
    $content = new ContentExpress();
    return $content->admin_modifyconfig();
}

/**
 * This is a standard function to modify the configuration parameters of the
 * module
 */
function ContentExpress_admin_modifymeconfig()
{
    $menu = new MenuExpress();
    return $menu->admin_modifyconfig();
}

/**
 * This is a standard function to modify the configuration parameters of the
 * module
 */
function ContentExpress_admin_modifymmeconfig()
{
    $menu = new MediaExpress();
    return $menu->admin_modifyconfig();
}

/**
 * This is a standard function to update the configuration parameters of the
 * module given the information passed back by the modification form
 */
function ContentExpress_admin_updatececonfig( $args )
{
    $content = new ContentExpress();
    return $content->admin_updateconfig( $args );
}

/**
 * This is a standard function to update the configuration parameters of the
 * module given the information passed back by the modification form
 */
function ContentExpress_admin_updatemeconfig( $args )
{
    $menu = new MenuExpress();
    return $menu->admin_updateconfig( $args );
}

/**
 * This is a standard function to update the configuration parameters of the
 * module given the information passed back by the modification form
 */
function ContentExpress_admin_updatemmeconfig( $args )
{
    $media = new MediaExpress();
    return $media->admin_updateconfig( $args );
}

/**
 * This is a standard function to manage the medias in the repository
 */
function ContentExpress_admin_mediamanager()
{
    $media = new MediaExpress();
    return $media->admin_mediamanager();
}

/**
 * This is a standard function to update the media in the repository
 */
function ContentExpress_admin_updatemedia($args)
{
    $media = new MediaExpress();
    return $media->admin_updatemedia( $args );
}

// function to build menu list, called by CE menu block
function ContentExpress_admin_build_menu( &$lists )
{
    return CommonExpress_build_item_list( $lists, "menu" );
}

// function to create standard footer
function ContentExpress_footer( &$output, $modinfo )
{
    $output->TableRowStart();
    $output->TableColStart( 2, 'center' );
    $output->Linebreak(2);
    $output->Text( "Powered by " );
    $output->URL( "http://xexpress.sourceforge.net", "Content Express ".$modinfo['version'] );
    $output->Text( " from " );
    $output->URL( "http://xexpress.sourceforge.net", "XExpress Development Team" );
    $output->TableColEnd();
    $output->TableRowEnd();
}
?>
