<?php
// $Id: CommonExpress.php,v 1.9 2003/05/21 14:15:29 linuxwarrior Exp $
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Module: CommonExpress
// Copyright (C) 2002 by the Content Express Development Team.
//                           Arising Group, Inc.
// http://www.widgetbox.net/
// http://xexpress.sourceforge.net/
// Original Author of file: Chester Chee
// Purpose of file:
//     Administrative API aux. methods (being used by both ContentExpress
// and MenuExpress, currently there are duplicate code between classes,
// need to review the code later on to remove the duplication)
// ----------------------------------------------------------------------

// This method is used to calculate the weight (or order) of the
// menu/content items in the tree.
// Need better algorithm in term of weight calculation
function CommonExpress_calculate_weight( $dbconn, $pntable, $type, $task, $id, $pid )
{
    // Load API.  Note that this is loading the user API in addition to
    // the administration API, that is because the user API contains
    // the function to obtain item information which is the first thing
    // that we need to do.  If the API fails to load an appropriate error
    // message is posted and the function returns
    if (!pnModAPILoad('ContentExpress', 'user')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return false;
    }

    // The user API function is called.  This takes the item ID which
    // we obtained from the input and gets us the information on the
    // appropriate item.  If the item does not exist we post an appropriate
    // message and return
    $method = "get_".$type."item";

    // yuky code here. need revisit later to do cleanup
    $idfield = "";
    if( $type == "content" ) { $idfield = "ceid"; $class = "ce"; }
    else if( $type == "menu" ) { $idfield = "meid"; $class = "me"; }

    $item = pnModAPIFunc('ContentExpress',
            'user',
            $method,
            array( $idfield => $id));

    $pitem = pnModAPIFunc('ContentExpress',
             'user',
             $method,
             array( $idfield => $pid ));

    if ($item != false) {

        // It's good practice to name the table and column definitions you
        // are getting - $table and $column don't cut it in more complex
        // modules
        $items_table = $pntable[$class.'_'.$type.'items'];
        $items_column = &$pntable[$class.'_'.$type.'items_column'];

        // Depends on the task, the weight is calculate slightly different.
        if( $task == 'up' ) {
            // Swap the weight with sibling item above as suggested by Philip Fletcher
            $weight1 = $pitem['weight'];
            $weight2 = $item['weight'];
        }
        else if( $task == 'down' ) {
            // Swap the weight with sibling item below as suggested by Philip Fletcher
            $weight1 = $item['weight'];
            $weight2 = $pitem['weight'];
        }
        else if ( $task == 'left' ) {
            // Identify the current immediate below siblings' id after insertion.
            $sql = "SELECT $items_column[id],
                           MIN($items_column[weight])
                    FROM $items_table
                    WHERE $items_column[weight] > '".$pitem['weight']."' AND
                          $items_column[parent_id] = '".$pitem['parent_id']."'
                    GROUP BY $items_column[id]
                    ORDER BY $items_column[weight]";

            $result = $dbconn->Execute($sql);

            if( $result != false ) {
                list( $bid, $bweight ) = $result->fields;

                if( !empty( $bweight )) {
                    $weight1 = ($pitem['weight'] + $bweight )/2;
                }
                else {
                    $weight1 = $pitem['weight'] + 5;
                }
            }
            else {
                $weight1 = $pitem['weight'] + 5;
            }
            $weight2 = -1;
        }
        else if( $task == 'right' ) {
            // Identify the current immediate above siblings' id after insertion.
            $sql = "SELECT $items_column[id],
                           MAX($items_column[weight])
                    FROM $items_table
                    WHERE $items_column[parent_id] = '".$pid."'
                    GROUP BY $items_column[id]
                    ORDER BY $items_column[weight] DESC";

            $result = $dbconn->Execute($sql);

            if( $result != false ) {
                list( $bid, $bweight ) = $result->fields;

                if( !empty( $bweight )) {
                    $weight1 = $bweight + 5;
                }
                else {
                    $weight1 = $item['weight'];
                }
            }
            else {
                $weight1 = $item['weight'];
            }
            $weight2 = -1;
        }
    }

    return array( $weight1, $weight2 );
}

/**
 * build item listing
 * This is a internal function that is called by new/edit item to build the parent item listing
 */
function CommonExpress_build_item_list(&$lists, $type, $exception = -1, $comparator = NULL, $mode = "" )
{
    $output = new pnHTML();

    // Load API.  Note that this is loading the user API, that is because the
    // user API contains the function to obtain item information which is the
    // first thing that we need to do.  If the API fails to load an appropriate
    // error message is posted and the function returns
    // Need explicit module name in order to have block to display correct information
    if (!pnModAPILoad('ContentExpress', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    // The user API function is called.  This takes the item ID which we
    // obtained from the input and gets us the information on the appropriate
    // item.  If the item does not exist we post an appropriate message and
    // return
    $method = "getall_".$type;
    $listing = pnModAPIFunc('ContentExpress',
                            'user',
                            $method,
                            array('modulemode' => $mode));

    if ($listing == false) {
        $output->Text(_MENUCONTENTNOSUCHITEM);
        return $output->GetOutput();
    }

    // Built the item tree
    $items = array();
    foreach($listing as $elem) {
        $id = $elem['id'];
        $parent_id = $elem['parent_id'];
        $title = $elem['title'];

        if(( isset( $comparator ) && $comparator( $elem )) ||
           ( !isset( $comparator ) &&
           ( $elem['active'] == 1 || $elem['status'] == 2 ))) {
            $items[($id+0)] = array( 'id'      => $id,
                                     'title'   => $title,
                                     'parent'  => ($parent_id+0),
                                     'child'   => array());
        }
    }

    // Identify children
    foreach( $items as $item ) {
        $id = $item['id'];
        $parent_id = $item['parent'];
        if( $parent_id > 0 && !empty( $items[$parent_id] )) {
            array_push( $items[$parent_id]['child'], $id );
        }
    }

    // Change the title to reflect parent child relationship
    foreach( $items as $id => $item ) {
        if( $item['parent'] == -1 ) {
            CommonExpress_build_item_tree( $items, $item );
        }
    }

    // Built the item list
    foreach( $items as $id => $item ) {

        $parent_id = $item['parent'];

        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        if( $exception == -1 ) {
            $lists[$id] = $output->Text( $item['title'] );
        }
        else {
            if( $parent_id > 0 ) {
                if( $parent_id != $exception && $id != $exception && !empty( $lists[$parent_id] )) {
                    $lists[$id] = $output->Text( $item['title'] ); 
                }
            } else if( $id != $exception ) {
                $lists[$id] = $output->Text( $item['title'] );
            }
        }
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
    }
}

/**
 * build item tree
 * This is a internal function that is called by build item list to build the item tree
 * recursively
 */
function CommonExpress_build_item_tree( &$items, &$item, $spacer = "" )
{
    $id = $item['id'];
    $child = $item['child'];
    $parent_id = $item['parent'];
    if( $parent_id > 0 ) {
        $items[$id]['title'] = $spacer."/".$items[$id]['title'];
    }
    if( count( $child ) > 0 ) {
        foreach( $child as $cid ) {
            CommonExpress_build_item_tree( $items, $items[$cid], $items[$id]['title'] );
        }
    }
}

// check to see if any of its child id along the downward path matches the curr_id
function CommonExpress_has_child( $list, $curr_id, $item_id )
{
    $result = false;
    $children = $list[$item_id]['child'];
    if( count( $children ) > 0 ) {
        foreach( $children as $child_id ) {
            if( $curr_id == $child_id ) {
                $result = true;
            } else {
                $result = CommonExpress_has_child( $list, $curr_id, $child_id );
            }
            if( $result ) { break; }
        }
    }
    return $result;
}

/**
 * build menu/content item tree
 * This is a internal function that is called by view menu/view content to build the menu/content item tree
 * recursively
 */
function CommonExpress_build_viewitems_tree( &$output, $typeid, $curr_id, $lists, &$item, $func, $spacer = "" )
{
    $row = array();
    $row[] = $item['title'];
    $child = $item['child'];
    $modinfo = pnModGetInfo(pnModGetIDFromName('ContentExpress'));
    $moddir = pnVarPrepForOS($modinfo['directory']);
    $itemid = $item['id'];
    $blank = "<img border=\"0\" width=\"12\" src=\"modules/$moddir/pnimages/blank.gif\">";
    $collapsedimg = "<a href=\"index.php?module=$moddir&type=admin&func=$func&$typeid=$itemid\"><img border=\"0\" width=\"12\" src=\"modules/$moddir/pnimages/squareplus.gif\"></a>"; 
    $expandedimg = "<a href=\"index.php?module=$moddir&type=admin&func=$func&$typeid=$itemid\"><img border=\"0\" width=\"12\" src=\"modules/$moddir/pnimages/squareminus.gif\"></a>"; 
    if ( !empty($item['actions']) ) { 
        if ( count ($child) > 0 ) {
            if( $curr_id == $itemid ||
                CommonExpress_has_child( $lists, $curr_id, $itemid )) {
                $levelspacer = $spacer.$expandedimg."&nbsp;";
            } else {
                $levelspacer = $spacer.$collapsedimg."&nbsp;";
            }
        } else {
            $levelspacer = $spacer.$blank."&nbsp;";
        }
        $row[0] = "$levelspacer$row[0]";
        $row[] = join( "&nbsp;|&nbsp;", $item['actions'] );
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->TableAddRow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);
        if( count( $child ) > 0 ) {
            $spacer = $spacer.$blank."&nbsp;";
            foreach( $child as $child_id ) {
                CommonExpress_build_viewitems_tree( $output, $typeid, $curr_id, $lists, $lists[$child_id],$func, $spacer );
            }
        }
   }
}

function CommonExpress_build_dynitems_tree( $items, &$dynitems, $curr_id )
{
    $curr_pid = -1;

    // Maintain the top level order by getting all the top level
    // menu/content item first in the current order (sorted by parent id
    // and weight)
    foreach( $items as $id => $item ) {
        if( $item['parent'] == -1 ) {
           $dynitems[$id] = $item;
        }
    }
    if( $curr_id > 0 ) {
        $curr_pid = $items[$curr_id]['parent'];
        // Get all the children and siblings of the current item
        foreach( $items as $id => $item ) {
            if( $item['parent'] == $curr_pid ||   // siblings
                $item['parent'] == $curr_id ) {   // children
                $dynitems[$item['id']] = $item;
            }
        }
        // Get all the intermediate parents (menu path) between
        // the top level and the current item
        while( $curr_pid > 0 ) {
            $dynitems[$curr_pid] = $items[$curr_pid];
            $curr_pid = $items[$curr_pid]['parent'];

            // Get all the siblings of the immediate parent item
            foreach( $items as $id => $item ) {
                if( $item['parent'] == $curr_pid ) {
                    $dynitems[$item['id']] = $item;
                }
            }
        }
    }
}
    
// function to build file list in media repository
function CommonExpress_build_medialist( &$lists, $selected = "" )
{
    $media_repository = pnModGetVar('MediaExpress', 'media_repository');
    $modinfo = pnModGetInfo(pnModGetIDFromName('ContentExpress'));
    $moddir = pnVarPrepForOS($modinfo['directory']);

    if( $dir = opendir( "modules/$moddir/$media_repository/" )) {
        while( false !== ( $file = readdir( $dir ))) {
            if( $file != "." && $file != ".." && $file != "CVS" ) {
                if( strcmp( "$media_repository/$file", $selected ) == 0 ) {
                    $lists[] = array( 'id' => "$media_repository/$file",
                                      'selected' => 1,
                                      'name' => "$media_repository/$file" );
                }
                else
                {
                    $lists[] = array( 'id' => "$media_repository/$file",
                                      'selected' => 0,
                                      'name' => "$media_repository/$file" );
                }
            }
        }
        closedir( $dir );
    }
}

function CommonExpress_build_editor_list()
{
    $lists = array();
    $enable_wysiwyg = pnModGetVar('ContentExpress', 'enable_wysiwyg');
    $modinfo = pnModGetInfo(pnModGetIDFromName('ContentExpress'));
    $moddir = pnVarPrepForOS($modinfo['directory']);

    if( $dir = opendir( "modules/$moddir/pneditor/" )) {
        while( false !== ( $file = readdir( $dir ))) {
            if( $file != "." && $file != ".." && $file != "pnCEHTML.php" ) {
                if( strcmp( "$file", $enable_wysiwyg ) == 0 ) {
                    $lists[] = array( 'id' => "$file",
                                      'selected' => 1,
                                      'name' => "$file" );
                }
                else
                {
                    $lists[] = array( 'id' => "$file",
                                      'selected' => 0,
                                      'name' => "$file" );
                }
            }
        }
        closedir( $dir );
    }
    return $lists;
}

function CommonExpress_getallblocks( $meid, $types, $currlang = "x_all" )
{
    // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
    // return arrays but we handle them differently.  For pnDBGetConn() we
    // currently just want the first item, which is the official database
    // handle.  For pnDBGetTables() we want to keep the entire tables array
    // together for easy reference later on
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // It's good practice to name the table and column definitions you are
    // getting - $table and $column don't cut it in more complex modules
    $blocks = $pntable['blocks'];
    $blocks_column = &$pntable['blocks_column'];

    // Get item - the formatting here is not mandatory, but it does make the
    // SQL statement relatively easy to read.  Also, separating out the sql
    // statement from the Execute() command allows for simpler debug operation
    // if it is ever needed
    $sql = "SELECT $blocks_column[bid],
                   $blocks_column[bkey],
                   $blocks_column[title],
                   $blocks_column[url],
                   $blocks_column[position],
                   $blocks_column[weight],
                   $blocks_column[mid],
                   $blocks_column[active],
                   $blocks_column[blanguage]
            FROM $blocks
            WHERE $blocks_column[mid] = $meid AND (";
    $count = 0;
    $total = count( $types );
    foreach( $types as $type ) {
        $sql .=   "$blocks_column[bkey] = '".$type."'";
        $count++;
        if( $count < $total ) {
            $sql .= " OR ";
        }
    }
    $sql .= "     ) AND
                  ($blocks_column[blanguage] = '".$currlang."' OR
                   $blocks_column[blanguage] = '' OR
                   $blocks_column[blanguage] = 'x_all')";
    $result = $dbconn->Execute($sql);

    // Check for an error with the database code, and if so set an appropriate
    // error message and return
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }

    // Check for no rows found, and if so return
    if ($result->EOF) {
        return false;
    }

    $items = array();

    // Put items into result array.  Note that each item is checked
    // individually to ensure that the user is allowed access to it before it
    // is added to the results array
    for (; !$result->EOF; $result->MoveNext()) {
        list($bid, $bkey, $title, $url, $position, $weight, $meid, $active, $language) = $result->fields;
        $items[] = array('bid' => $bid,
                         'bkey' => $bkey,
                         'title' => $title,
                         'url' => $url,
                         'position' => $position,
                         'weight' => $weight,
                         'meid' => $meid,
                         'active' => $active,
                         'language' => $language);
    }

    // All successful database queries produce a result set, and that result
    // set should be closed when it has been finished with
    $result->Close();

    // Return the items
    return $items;
}

function CommonExpress_getblock( $meid, $bid )
{
    // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
    // return arrays but we handle them differently.  For pnDBGetConn() we
    // currently just want the first item, which is the official database
    // handle.  For pnDBGetTables() we want to keep the entire tables array
    // together for easy reference later on
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // It's good practice to name the table and column definitions you are
    // getting - $table and $column don't cut it in more complex modules
    $blocks = $pntable['blocks'];
    $blocks_column = &$pntable['blocks_column'];

    // Get item - the formatting here is not mandatory, but it does make the
    // SQL statement relatively easy to read.  Also, separating out the sql
    // statement from the Execute() command allows for simpler debug operation
    // if it is ever needed
    $sql = "SELECT $blocks_column[bid],
                   $blocks_column[bkey],
                   $blocks_column[title],
                   $blocks_column[url],
                   $blocks_column[position],
                   $blocks_column[content],
                   $blocks_column[weight],
                   $blocks_column[mid],
                   $blocks_column[active],
                   $blocks_column[blanguage]
            FROM $blocks
            WHERE $blocks_column[bid] = $bid AND
                  $blocks_column[mid] = $meid";
    $result = $dbconn->Execute($sql);

    // Check for an error with the database code, and if so set an appropriate
    // error message and return
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }

    // Check for no rows found, and if so return
    if ($result->EOF) {
        return false;
    }

    // Put item into result.  Note that each item is checked
    // individually to ensure that the user is allowed access to it before it
    // is added to the results array
    list($bid, $bkey, $title, $url, $position, $content, $weight, $meid, $active, $language) = $result->fields;
    $item = array('bid' => $bid,
                  'bkey' => $bkey,
                  'title' => $title,
                  'url' => $url,
                  'position' => $position,
                  'content' => $content,
                  'weight' => $weight,
                  'meid' => $meid,
                  'active' => $active,
                  'language' => $language);

    // All successful database queries produce a result set, and that result
    // set should be closed when it has been finished with
    $result->Close();

    // Return the items
    return $item;
}

function CommonExpress_getallblockstitle()
{
    // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
    // return arrays but we handle them differently.  For pnDBGetConn() we
    // currently just want the first item, which is the official database
    // handle.  For pnDBGetTables() we want to keep the entire tables array
    // together for easy reference later on
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // It's good practice to name the table and column definitions you are
    // getting - $table and $column don't cut it in more complex modules
    $blocks = $pntable['blocks'];
    $blocks_column = &$pntable['blocks_column'];

    // Get item - the formatting here is not mandatory, but it does make the
    // SQL statement relatively easy to read.  Also, separating out the sql
    // statement from the Execute() command allows for simpler debug operation
    // if it is ever needed
    $sql = "SELECT $blocks_column[bid],
                   $blocks_column[title],
                   $blocks_column[blanguage]
            FROM $blocks";
    $result = $dbconn->Execute($sql);

    // Check for an error with the database code, and if so set an appropriate
    // error message and return
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }

    // Check for no rows found, and if so return
    if ($result->EOF) {
        return false;
    }

    $items = array();
    for( ; !$result->EOF; $result->MoveNext()) {

         // Put item into result.  Note that each item is checked
         // individually to ensure that the user is allowed access to it before it
         // is added to the results array
         list($bid, $title, $language) = $result->fields;
         $items[(int)$bid] = array('bid' => $bid,
                                   'title' => $title,
                                   'language' => $language);
    }

    // All successful database queries produce a result set, and that result
    // set should be closed when it has been finished with
    $result->Close();

    // Return the items
    return $items;
}

function CommonExpress_display_themeable_anchor( $mytheme, $anchor, $label, $action )
{
    $result = "";
    $output = new pnHTML();

    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT); //fix suggested by oleg.
 
    // Make sure if print action, it will open a new window to display the printer friendly page
    if( $action == "print" ) {
        $anchor .= "\" target=\"_blank";
    }

    if( file_exists( "themes/$mytheme/images/$action.png" )) {
        $result = $output->URL( $anchor, "<img class=\"icon\" border=\"0\" src=\"themes/$mytheme/images/$action.png\">", true );
    }
    else if( file_exists( "themes/$mytheme/images/$action.jpg" )) {
        $result = $output->URL( $anchor, "<img class=\"icon\" border=\"0\" src=\"themes/$mytheme/images/$action.jpg\">", true );
    }
    else if( file_exists( "themes/$mytheme/images/$action.gif" )) {
        $result = $output->URL( $anchor, "<img class=\"icon\" border=\"0\" src=\"themes/$mytheme/images/$action.gif\">", true );
    }
    else {
        $result = $output->URL( $anchor, $label );
    }

    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
 
    return $result;
}

/**
 * Get a session server variable
 *
 * @param name name of the server variable
 */
function CommonExpress_getservvar( $name )
{
    if( CommonExpress_phpminversion( "4.1.0" )) {
        global $_SERVER;
        return $_SERVER[$name];
    } else {
        global $HTTP_SERVER_VARS;
        return $HTTP_SERVER_VARS[$name];
    }
}

/**
 * Get a session environment variable
 *
 * @param name name of the environment variable
 */
function CommonExpress_getenvvar( $name )
{
    if( CommonExpress_phpminversion( "4.1.0" )) {
        global $_ENV;
        return $_ENV[$name];
    } else {
        global $HTTP_ENV_VARS;
        return $HTTP_ENV_VARS[$name];
    }
}

/**
 * @param   version - mininum version you have specified
 * @returns bool
 * @return  true    - if version >= mininum version you have specified
 *          false   - if otherwise
 */
function CommonExpress_phpminversion( $version )
{
    $minver = explode(".", $version );
    $curver = explode(".", phpversion());
    if (($curver[0] < $minver[0]) ||
        (($curver[0] == $minver[0]) && ($curver[1] < $minver[1])) ||
        (($curver[0] == $minver[0]) && ($curver[1] == $minver[1]) && ($curver[2][0] < $minver[2][0])))
        return false;
    else
        return true;
}
?>
