<?php

// $Id: MenuExpress.php,v 1.51 2003/05/26 14:24:18 linuxwarrior Exp $
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Module: MenuExpress
// Copyright (C) 2002 by the Content Express Development Team.
//                           Arising Group, Inc.
// http://xexpress.sourceforge.net/
// Original Author of file: Chester Chee
// Purpose of file:  MenuExpress class
// ----------------------------------------------------------------------

$ModName = basename( dirname( dirname( __FILE__ )));

class MenuExpress
{
    function pntables( &$pntable )
    {
        // Get the name for the menu item table.  This is not necessary
        // but helps in the following statements and keeps them readable
        $menuitems = pnConfigGetVar('prefix') . '_me_menuitems';
    
        // Set the table name
        $pntable['me_menuitems'] = $menuitems;
    
        // Set the column names.  Note that the array has been formatted
        // on-screen to be very easy to read by a user.
        $pntable['me_menuitems_column'] = array('id'                 => $menuitems . '.mc_id',
                                                'parent_id'          => $menuitems . '.mc_parent_id',
                                                'block_id'           => $menuitems . '.mc_block_id',
                                                'language'           => $menuitems . '.mc_language',
                                                'title'              => $menuitems . '.mc_title',
                                                'menutype'           => $menuitems . '.mc_type',
                                                'newwindow'          => $menuitems . '.mc_newwindow',
                                                'uri'                => $menuitems . '.mc_uri',
                                                'start_date'         => $menuitems . '.mc_start_date',
                                                'end_date'           => $menuitems . '.mc_end_date',
                                                'status'             => $menuitems . '.mc_status',
                                                'weight'             => $menuitems . '.mc_weight',
                                                'rollover_img1'      => $menuitems . '.mc_rollover_img1',
                                                'rollover_img2'      => $menuitems . '.mc_rollover_img2',
                                                'bg_img'             => $menuitems . '.mc_bg_img',
                                                'rollover_img1_file' => $menuitems . '.mc_rollover_img1_file',
                                                'rollover_img2_file' => $menuitems . '.mc_rollover_img2_file',
                                                'bg_img_file'        => $menuitems . '.mc_bg_img_file',
                                                'rollover_img1_size' => $menuitems . '.mc_rollover_img1_size',
                                                'rollover_img2_size' => $menuitems . '.mc_rollover_img2_size',
                                                'bg_img_size'        => $menuitems . '.mc_bg_img_size',
                                                'rollover_img1_type' => $menuitems . '.mc_rollover_img1_type',
                                                'rollover_img2_type' => $menuitems . '.mc_rollover_img2_type',
                                                'bg_img_type'        => $menuitems . '.mc_bg_img_type');
    }

    function init( $dbconn )
    {
        $pntable = pnDBGetTables();

        // It's good practice to name the table and column definitions you
        // are getting - $table and $column don't cut it in more complex
        // modules
        $menuitems_table = $pntable['me_menuitems'];
        $menuitems_column = &$pntable['me_menuitems_column'];
        $now = strftime( "%Y-%m-%d %H:%M:%S", time());
        // Create the table - the formatting here is not mandatory, but it does
        // make the SQL statement relatively easy to read.  Also, separating out
        // the SQL statement from the Execute() command allows for simpler
        // debug operation if it is ever needed
        $sql  = "CREATE TABLE $menuitems_table ( ";
        $sql .= "$menuitems_column[id] int(11) NOT NULL auto_increment, ";
        $sql .= "$menuitems_column[parent_id] int(11) NOT NULL DEFAULT -1, ";
        $sql .= "$menuitems_column[block_id] int(11) NOT NULL DEFAULT -1, ";
        $sql .= "$menuitems_column[language] varchar(30) NOT NULL, ";
        $sql .= "$menuitems_column[title] text NOT NULL, ";
        $sql .= "$menuitems_column[menutype] tinyint(4) NOT NULL DEFAULT 0, ";
        $sql .= "$menuitems_column[newwindow] tinyint(4) NOT NULL DEFAULT 0, ";
        $sql .= "$menuitems_column[uri] text NOT NULL, ";
        $sql .= "$menuitems_column[start_date] datetime NOT NULL DEFAULT '$now', ";
        $sql .= "$menuitems_column[end_date] datetime NOT NULL DEFAULT '2038-01-18 00:00:00', ";
        $sql .= "$menuitems_column[status] tinyint(4) NOT NULL DEFAULT '1', ";
        $sql .= "$menuitems_column[weight] float NOT NULL DEFAULT 0, ";
        $sql .= "$menuitems_column[rollover_img1] blob NULL, ";
        $sql .= "$menuitems_column[rollover_img2] blob NULL, ";
        $sql .= "$menuitems_column[bg_img] blob NULL, ";
        $sql .= "$menuitems_column[rollover_img1_file] text NULL, ";
        $sql .= "$menuitems_column[rollover_img2_file] text NULL, ";
        $sql .= "$menuitems_column[bg_img_file] text NULL, ";
        $sql .= "$menuitems_column[rollover_img1_size] int(11) NOT NULL DEFAULT 0, ";
        $sql .= "$menuitems_column[rollover_img2_size] int(11) NOT NULL DEFAULT 0, ";
        $sql .= "$menuitems_column[bg_img_size] int(11) NOT NULL DEFAULT 0, ";
        $sql .= "$menuitems_column[rollover_img1_type] text NULL, ";
        $sql .= "$menuitems_column[rollover_img2_type] text NULL, ";
        $sql .= "$menuitems_column[bg_img_type] text NULL, ";
        $sql .= "PRIMARY KEY (mc_id))";
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _CREATETABLEFAILED ." - $menuitems_table");
            return false;
        }

        pnModSetVar('MenuExpress', 'enable_qadmin', 1 );
        pnModSetVar('MenuExpress', 'pnmenu_style', 0 );
        pnModSetVar('MenuExpress', 'max_img_size', 3000 );

        return true;
    }

    function upgrade($oldversion)
    {
	list($dbconn) = pnDBGetConn();
	$pntable = pnDBGetTables();
        $menuitems_table = $pntable['me_menuitems'];
        $menuitems_column = &$pntable['me_menuitems_column'];
        
	switch( $oldversion ) {
            case "1.0":
            case "1.1":
            case "1.1b":
            case "1.1c":
            case "1.1d":
            case "1.2":
            case "1.2.1":
            case "1.2.2":
                // Fix bug in language setting for menu item. The newer version
                // of PN seems to change the All language from '' to 'x_all'
                $old_menuitems_table = pnConfigGetVar('prefix') . '_ContentExpress_menuitems';
    
                // Change menu items table to fix language problem
                $sql  = "UPDATE $old_menuitems_table ";
                $sql .= "SET mc_language = 'x_all' ";
                $sql .= "WHERE mc_language = ''";
                $dbconn->Execute($sql);
    
                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - $old_menuitems_table");
                    return false;
                }
            case "1.2.3":
            case "1.2.4":
            case "1.2.4.1":
            case "1.2.4.2":

                // Change the name of the tables with the new convention
                $old_menuitems_table = pnConfigGetVar('prefix') . '_ContentExpress_menuitems';

                $sql  = "ALTER TABLE $old_menuitems_table ";
                $sql .= "RENAME AS $menuitems_table";

                $dbconn->Execute($sql);

                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - Rename $old_menuitems_table to $menuitems_table");
                    return false;
                }

                // Alter table schema to add menu item type, rename anchor to uri,
                // add start date and end date and status
                $now = strftime( "%Y-%m-%d %H:%M:%S", time());
                $sql  = "ALTER TABLE $menuitems_table ";
                $sql .= "CHANGE mc_anchor $menuitems_column[uri] text NOT NULL, ";
                $sql .= "ADD $menuitems_column[menutype] tinyint(4) NOT NULL DEFAULT '0' AFTER mc_title, ";
                $sql .= "ADD $menuitems_column[start_date] datetime NOT NULL DEFAULT '$now' AFTER mc_uri, ";
                $sql .= "ADD $menuitems_column[end_date] datetime NOT NULL DEFAULT '2038-01-18 00:00:00' AFTER mc_start_date, ";
                $sql .= "ADD $menuitems_column[status] tinyint(4) NOT NULL DEFAULT '1' AFTER mc_end_date ";

                $dbconn->Execute($sql);
    
                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - Change schema $menuitems_table");
                    return false;
                }

                // Migrate existing data that are ContentExpress related to column uri
                $uri = pnModURL('ContentExpress', 'user', 'display');
                $menus = array();

                $sql  = "SELECT mc_id, mc_anchor_id ";
                $sql .= "FROM $menuitems_table ";
                $sql .= "WHERE mc_anchor_id > -1";

                $result = $dbconn->Execute($sql);
    
                for (; !$result->EOF; $result->MoveNext()) {
                    list($id, $anchor_id) = $result->fields;
                    $menus[ $id ] = $anchor_id;
                }

                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - Change schema $menuitems_table");
                    return false;
                }

                if( !empty( $menus )) {
                    foreach( $menus as $id => $anchor_id ) {
                        $sql  = "UPDATE $menuitems_table ";
                        $sql .= "SET $menuitems_column[uri] = '$uri&meid=$id&ceid=$anchor_id', ";
                        $sql .= "    $menuitems_column[menutype] = 3, ";
                        $sql .= "    $menuitems_column[status] = 2 ";
                        $sql .= "WHERE mc_anchor_id > -1 AND mc_id = $id";

                        $dbconn->Execute($sql);
    
                        // Check for an error with the database code, and if so set an
                        // appropriate error message and return
                        if ($dbconn->ErrorNo() != 0) {
                            pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - Migrate data module menu type $menuitems_table");
                            return false;
                        }
                    }
                }

                // Migrate custom URL type menu items
                $sql  = "UPDATE $menuitems_table ";
                $sql .= "SET $menuitems_column[menutype] = 4, ";
                $sql .= "    $menuitems_column[status] = 2 ";
                $sql .= "WHERE mc_anchor_id = -1";

                $dbconn->Execute($sql);

                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - Migrate data custom url menu type $menuitems_table");
                    return false;
                }

                // Migrate title type menu items
                $sql  = "UPDATE $menuitems_table ";
                $sql .= "SET $menuitems_column[menutype] = 2, ";
                $sql .= "    $menuitems_column[status] = 2 ";
                $sql .= "WHERE mc_anchor_id = -2";

                $dbconn->Execute($sql);

                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - Migrate data title menu type $menuitems_table");
                    return false;
                }

                // Migrate spacer type menu items
                $sql  = "UPDATE $menuitems_table ";
                $sql .= "SET $menuitems_column[menutype] = 1, ";
                $sql .= "    $menuitems_column[status] = 2 ";
                $sql .= "WHERE mc_anchor_id = -3";

                $dbconn->Execute($sql);

                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - Migrate data spacer menu type $menuitems_table");
                    return false;
                }

                // Remove the useless column after data migration
                $sql  = "ALTER TABLE $menuitems_table ";
                $sql .= "DROP mc_anchor_id";

                $dbconn->Execute($sql);

                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - Drop anchor_id $menuitems_table");
                    return false;
                }

                $pnmenu = pnModGetVar('ContentExpress', 'pnmenu_style');
                pnModDelVar('ContentExpress', 'pnmenu_style');
                pnModSetVar('MenuExpress', 'enable_qadmin', 1);
                pnModSetVar('MenuExpress', 'pnmenu_style', $pnmenu);

            case "1.2.4.3":
            case "1.2.4.4":
            case "1.2.4.5":
            case "1.2.4.6":
                // Add new field for option to open menu item in new window
                $sql  = "ALTER TABLE $menuitems_table ";
                $sql .= "ADD $menuitems_column[newwindow] tinyint(4) NOT NULL DEFAULT '0' AFTER mc_type";

                $dbconn->Execute($sql);
                
                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - Add newwindow $menuitems_table");
                    return false;
                }
            case "1.2.4.7":
            case "1.2.4.8":
            case "1.2.4.9":
                $sql = "ALTER TABLE $menuitems_table ";
                $sql.= "DROP mc_active, ";
                $sql.= "ADD $menuitems_column[rollover_img1] blob NULL AFTER mc_weight, ";
                $sql.= "ADD $menuitems_column[rollover_img2] blob NULL AFTER mc_rollover_img1, ";
                $sql.= "ADD $menuitems_column[bg_img] blob NULL AFTER mc_rollover_img2, ";
                $sql.= "ADD $menuitems_column[rollover_img1_file] text DEFAULT '' AFTER mc_bg_img, ";
                $sql.= "ADD $menuitems_column[rollover_img2_file] text DEFAULT '' AFTER mc_rollover_img1_file, ";
                $sql.= "ADD $menuitems_column[bg_img_file] text DEFAULT '' AFTER mc_rollover_img2_file, ";
                $sql.= "ADD $menuitems_column[rollover_img1_size] int(11) NOT NULL DEFAULT '0' AFTER mc_bg_img_file, ";
                $sql.= "ADD $menuitems_column[rollover_img2_size] int(11) NOT NULL DEFAULT '0' AFTER mc_rollover_img1_size, ";
                $sql.= "ADD $menuitems_column[bg_img_size] int(11) NOT NULL DEFAULT '0' AFTER mc_rollover_img2_size, ";
                $sql.= "ADD $menuitems_column[rollover_img1_type] text DEFAULT '' AFTER mc_bg_img_size, ";
                $sql.= "ADD $menuitems_column[rollover_img2_type] text DEFAULT '' AFTER mc_rollover_img1_type, ";
                $sql.= "ADD $menuitems_column[bg_img_type] text DEFAULT '' AFTER mc_rollover_img2_type;";

                $dbconn->Execute($sql);

                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - Add images $menuitems_table");
                    return false;
                }
                pnModSetVar('MenuExpress', 'max_img_size', 3000 );
            case "1.2.4.10":
            case "1.2.5.1":
            case "1.2.5.2":
            case "1.2.5.3":
            case "1.2.5.4":
                break;
        }
        return true;
    }

    function remove()
    {
        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn()
        // we currently just want the first item, which is the official
        // database handle.  For pnDBGetTables() we want to keep the entire
        // tables array together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
    
        // Drop the table - for such a simple command the advantages of separating
        // out the SQL statement from the Execute() command are minimal, but as
        // this has been done elsewhere it makes sense to stick to a single method
        $sql = "DROP TABLE $pntable[me_menuitems]";
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            // Report failed deletion attempt
            pnSessionSetVar('errormsg', _DELETETABLEFAILED ." - $pntable[me_menuitems]");
            return false;
        }
    
        // Delete any module variables
        pnModDelVar('MenuExpress', 'enable_qadmin' );
        pnModDelVar('MenuExpress', 'pnmenu_style' );
        pnModDelVar('MenuExpress', 'max_img_size' );

        return true;
    }

    function version( &$modversion )
    {
        $modversion['name'] = 'MenuExpress';
        $modversion['version'] = '1.2.6.0';
        $modversion['description'] = 'Menus Management Module';
        $modversion['credits'] = 'docs/credits.txt';
        $modversion['help'] = 'docs/help.txt';
        $modversion['changelog'] = 'docs/changelog.txt';
        $modversion['license'] = 'docs/license.txt';
        $modversion['official'] = 0;
        $modversion['author'] = 'Chester Chee, Philip Stutchbury, Steven Chen, Brave Cobra';
        $modversion['contact'] = 'http://xexpress.sourceforge.net/';
        $modversion['admin'] = 1;
        $modversion['securityschema'] = array( 
            'MenuExpress::Menu' => 'Block id:Menu title:Menu id',
            'MenuExpress::Menublock' => 'Block title::block ID' );
    }

    function api_create( $args )
    {
        // Get arguments from argument array - all arguments to this function
        // should be obtained from the $args array, getting them from other
        // places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        extract($args);
    
        // Argument check - make sure that all required arguments are present,
        // if not then set an appropriate error message and return
        if ((!isset($parent_id)) || (!isset($language)) || (!isset($title)) ||
            (!isset($menutype)) || (!isset( $status )) || (!isset($weight))) {
            pnSessionSetVar('errormsg', _MODARGSERROR);
            return false;
        }
    
        if(empty($bid)) { $bid = -1; }
        if(empty($uri)) { $uri = ""; }
        if(empty($start_date)) { $start_date = strftime( "%Y-%m-%d %H:%M:%S", time()); }
        if(empty($end_date)) { $end_date = "2038-01-18 00:00:00"; }
        if(empty($newwindow)) { $newwindow = 0; }
    
        // Security check - important to do this as early on as possible to 
        // avoid potential security holes or just too much wasted processing
        if (!pnSecAuthAction(0, 'MenuExpress::Menu', "::", ACCESS_ADD)) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOAUTH);
            return false;
        }
    
        // Need to parse the URI format to make sure it is translate to absolute URI

        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn()
        // we currently just want the first item, which is the official
        // database handle.  For pnDBGetTables() we want to keep the entire
        // tables array together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
    
        // It's good practice to name the table and column definitions you
        // are getting - $table and $column don't cut it in more complex
        // modules
        $menuitems_table = $pntable['me_menuitems'];
        $menuitems_column = &$pntable['me_menuitems_column'];
    
        // Get the max weight for the current item with the corresponding parent id
        $sql  = "SELECT MAX($menuitems_column[weight]) ";
        $sql .= "FROM $menuitems_table ";
        $sql .= "WHERE $menuitems_column[parent_id] = $parent_id";
    
        $result = $dbconn->Execute($sql);
    
        if( $result != false ) {
            list( $max_weight ) = $result->fields;
            if( !empty( $max_weight )) {
                $weight = $max_weight+1;
            }
        } else {
            $weight = 1;
        }
    
        // Get next ID in table - this is required prior to any insert that
        // uses a unique ID, and ensures that the ID generation is carried
        // out in a database-portable fashion
        $nextId = $dbconn->GenId($menuitems_table);
    
        // Add item - the formatting here is not mandatory, but it does make
        // the SQL statement relatively easy to read.  Also, separating out
        // the sql statement from the Execute() command allows for simpler
        // debug operation if it is ever needed
        $sql  = "INSERT INTO $menuitems_table ( ";
        $sql .= " $menuitems_column[id], ";
        $sql .= " $menuitems_column[parent_id], ";
        $sql .= " $menuitems_column[block_id], ";
        $sql .= " $menuitems_column[language], ";
        $sql .= " $menuitems_column[title], ";
        $sql .= " $menuitems_column[menutype], ";
        $sql .= " $menuitems_column[newwindow], ";
        $sql .= " $menuitems_column[uri], ";
        $sql .= " $menuitems_column[start_date], ";
        $sql .= " $menuitems_column[end_date], ";
        $sql .= " $menuitems_column[status], ";
        $sql .= " $menuitems_column[weight], ";
        $sql .= " $menuitems_column[rollover_img1], ";
        $sql .= " $menuitems_column[rollover_img2], ";
        $sql .= " $menuitems_column[bg_img], ";
        $sql .= " $menuitems_column[rollover_img1_file], ";
        $sql .= " $menuitems_column[rollover_img2_file], ";
        $sql .= " $menuitems_column[bg_img_file], ";
        $sql .= " $menuitems_column[rollover_img1_size], ";
        $sql .= " $menuitems_column[rollover_img2_size], ";
        $sql .= " $menuitems_column[bg_img_size], ";
        $sql .= " $menuitems_column[rollover_img1_type], ";
        $sql .= " $menuitems_column[rollover_img2_type], ";
        $sql .= " $menuitems_column[bg_img_type] ";
        $sql .= ") VALUES ( ";
        $sql .= " $nextId, ";
        $sql .= " " . pnVarPrepForStore($parent_id) . ", ";
        $sql .= " " . pnVarPrepForStore($bid) . ", ";
        $sql .= " '" . pnVarPrepForStore($language) . "', ";
        $sql .= " '" . pnVarPrepForStore($title) . "', ";
        $sql .= " " . pnVarPrepForStore($menutype) . ", ";
        $sql .= " " . pnVarPrepForStore($newwindow) . ", ";
        $sql .= " '" . pnVarPrepForStore($uri) . "', ";
        $sql .= " '" . pnVarPrepForStore($start_date) . "', ";
        $sql .= " '" . pnVarPrepForStore($end_date) . "', ";
        $sql .= " '" . pnVarPrepForStore($status) . "', ";
        $sql .= " " . pnVarPrepForStore($weight) . ", ";
        $sql .= " '" . pnVarPrepForStore($rollover_img1) . "', ";
        $sql .= " '" . pnVarPrepForStore($rollover_img2) . "', ";
        $sql .= " '" . pnVarPrepForStore($bg_img) . "', ";
        $sql .= " '" . pnVarPrepForStore($rollover_img1_file) . "', ";
        $sql .= " '" . pnVarPrepForStore($rollover_img2_file) . "', ";
        $sql .= " '" . pnVarPrepForStore($bg_img_file) . "', ";
        $sql .= " " . pnVarPrepForStore($rollover_img1_size) . ", ";
        $sql .= " " . pnVarPrepForStore($rollover_img2_size) . ", ";
        $sql .= " " . pnVarPrepForStore($bg_img_size) . ", ";
        $sql .= " '" . pnVarPrepForStore($rollover_img1_type) . "', ";
        $sql .= " '" . pnVarPrepForStore($rollover_img2_type) . "', ";
        $sql .= " '" . pnVarPrepForStore($bg_img_type) . "')";
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _CREATEFAILED);
            return false;
        }
    
        // Get the ID of the item that we inserted.  It is possible, although
        // very unlikely, that this is different from $nextId as obtained
        // above, but it is better to be safe than sorry in this situation
        $id = $dbconn->PO_Insert_ID($menuitems_table, $menuitems_column['id']);
    
        // Let any hooks know that we have created a new item.  As this is a
        // create hook we're passing 'meid' as the extra info, which is the
        // argument that all of the other functions use to reference this
        // item
        pnModCallHooks('item', 'create', $id, 'meid');
    
        // Return the id of the newly created item to the calling process
        return $id;
    }

    function api_delete( $args )
    {
        // Get arguments from argument array - all arguments to this function
        // should be obtained from the $args array, getting them from other
        // places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        extract($args);
    
        // Argument check - make sure that all required arguments are present,
        // if not then set an appropriate error message and return
        if (!isset($meid)) {
            pnSessionSetVar('errormsg', _MODARGSERROR);
            return false;
        }
    
        // Load API.  Note that this is loading the user API in addition to
        // the administration API, that is because the user API contains
        // the function to obtain item information which is the first thing
        // that we need to do.  If the API fails to load an appropriate error
        // message is posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'user')) {
            pnSessionSetVar('errormsg', _LOADFAILED.":ME:api_delete");
            return false;
        }
    
        // The user API function is called.  This takes the item ID which
        // we obtained from the input and gets us the information on the
        // appropriate item.  If the item does not exist we post an appropriate
        // message and return
        $item = pnModAPIFunc('ContentExpress',
                'user',
                'get_menuitem',
                array('meid' => $meid));
    
        if ($item == false) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOSUCHITEM);
            return false;
        }
    
        // Security check - important to do this as early on as possible to 
        // avoid potential security holes or just too much wasted processing.
        // However, in this case we had to wait until we could obtain the item
        // name to complete the instance information so this is the first
        // chance we get to do the check
        if (!pnSecAuthAction(0, 'MenuExpress::Menu', ":$item[title]:$meid", ACCESS_DELETE)) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOAUTH);
            return false;
        }
    
        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn()
        // we currently just want the first item, which is the official
        // database handle.  For pnDBGetTables() we want to keep the entire
        // tables array together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
    
        // It's good practice to name the table and column definitions you
        // are getting - $table and $column don't cut it in more complex
        // modules
        $menuitems_table = $pntable['me_menuitems'];
        $menuitems_column = &$pntable['me_menuitems_column'];
    
        // Need to check to see if this menu item has any children, if so, need to
        // shift them one level up so it won't become orphanage.
        $sql  = "UPDATE $menuitems_table ";
        $sql .= "SET $menuitems_column[parent_id] = " . pnVarPrepForStore($item['parent_id']) . " ";
        $sql .= "WHERE $menuitems_column[parent_id] = " . pnVarPrepForStore($meid);
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _DELETEFAILED);
            return false;
        }
    
        // Delete the item - the formatting here is not mandatory, but it does
        // make the SQL statement relatively easy to read.  Also, separating
        // out the sql statement from the Execute() command allows for simpler
        // debug operation if it is ever needed
        $sql  = "DELETE FROM $menuitems_table ";
        $sql .= "WHERE $menuitems_column[id] = " . pnVarPrepForStore($meid);
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _DELETEFAILED);
            return false;
        }
    
        // Let any hooks know that we have deleted an item.  As this is a
        // delete hook we're not passing any extra info
        pnModCallHooks('item', 'delete', $meid, '');
    
        // Let the calling process know that we have finished successfully
        return true;
    }

    function api_update( $args )
    {
        // Get arguments from argument array - all arguments to this function
        // should be obtained from the $args array, getting them from other
        // places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        extract($args);
    
        // Argument check - make sure that all required arguments are present,
        // if not then set an appropriate error message and return
        if ((!isset($meid)) || (!isset($parent_id)) || (!isset($bid)) || (!isset($language)) ||
            (!isset($title)) || (!isset($menutype)) || (!isset($status)) || (!isset($weight))) {
            pnSessionSetVar('errormsg', _MODARGSERROR);
            return false;
        }
    
        if( empty( $uri )) { $uri = ""; }
        if( empty( $start_date )) { $start_date = strftime( "%Y-%m-%d %H:%M:%S", time()); }
        if( empty( $end_date )) { $end_date = "2038-01-18 00:00:00"; }
        if( empty( $newwindow )) { $newwindow = 0; }
    
        // Load API.  Note that this is loading the user API in addition to
        // the administration API, that is because the user API contains
        // the function to obtain item information which is the first thing
        // that we need to do.  If the API fails to load an appropriate error
        // message is posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'user')) {
            pnSessionSetVar('errormsg', _LOADFAILED.":ME:api_update");
            return false;
        }
    
        // The user API function is called.  This takes the item ID which
        // we obtained from the input and gets us the information on the
        // appropriate item.  If the item does not exist we post an appropriate
        // message and return
        $item = pnModAPIFunc('ContentExpress',
                'user',
                'get_menuitem',
                array('meid' => $meid ));
    
        if ($item == false) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOSUCHITEM);
            return false;
        }
    
        // Security check - important to do this as early on as possible to 
        // avoid potential security holes or just too much wasted processing.
        // However, in this case we had to wait until we could obtain the item
        // name to complete the instance information so this is the first
        // chance we get to do the check
    
        // Note that at this stage we have two sets of item information, the
        // pre-modification and the post-modification.  We need to check against
        // both of these to ensure that whoever is doing the modification has
        // suitable permissions to edit the item otherwise people can potentially
        // edit areas to which they do not have suitable access
        if (!pnSecAuthAction(0, 'MenuExpress::Menu', "$btitle:$item[title]:$meid", ACCESS_EDIT) &&
            !pnSecAuthAction(0, 'MenuExpress::Menu', "$bid:$item[title]:$meid:", ACCESS_EDIT)) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOAUTH);
            return false;
        }
        if (!pnSecAuthAction(0, 'MenuExpress::Menu', "$btitle:$title:$meid", ACCESS_EDIT) &&
            !pnSecAuthAction(0, 'MenuExpress::Menu', "$bid:$title:$meid", ACCESS_EDIT)) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOAUTH);
            return false;
        }
    
        // Process the deletion request first
        if( $rollover_img1_del && file_exists( $item['rollover_img1_file'] )) {
            unlink( $item['rollover_img1_file'] );
        }

        if( $rollover_img2_del && file_exists( $item['rollover_img2_file'] )) {
            unlink( $item['rollover_img2_file'] );
        }

        if( $bg_img_del && file_exists( $item['bg_img_file'] )) {
            unlink( $item['bg_img_file'] );
        }

        // Move the temp file to pncache directory
        if( is_uploaded_file( $rollover_img1_file ) &&
	    ($rollover_img1 != "" && $rollover_img1 != "none" )) {
            $cache_file = "modules/ContentExpress/pncache/$rollover_img1_name";
            if( !move_uploaded_file( $rollover_img1_file, $cache_file )) {
                pnSessionSetVar( 'errormsg', _MENUCONTENTIMGCOPYFAILED );
                return false;
            }
            chmod( $cache_file, 0644 );
            $rollover_img1_file = $cache_file;
        }
        if( is_uploaded_file( $rollover_img2_file ) &&
	    ( $rollover_img2 != "" && $rollover_img2 != "none" )) {
            $cache_file = "modules/ContentExpress/pncache/$rollover_img2_name";
            if( !move_uploaded_file( $rollover_img2_file, $cache_file )) {
                pnSessionSetVar( 'errormsg', _MENUCONTENTIMGCOPYFAILED );
                return false;
            }
            chmod( $cache_file, 0644 );
            $rollover_img2_file = $cache_file;
        }
        if( is_uploaded_file( $bg_img_file ) &&
	    ( $bg_img != "" && $bg_img != "none" )) {
            $cache_file = "modules/ContentExpress/pncache/$bg_img_name";
            if( !move_uploaded_file( $bg_img_file, $cache_file )) {
                pnSessionSetVar( 'errormsg', _MENUCONTENTIMGCOPYFAILED );
                return false;
            }
            chmod( $cache_file, 0644 );
            $bg_img_file = $cache_file;
        }

        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn()
        // we currently just want the first item, which is the official
        // database handle.  For pnDBGetTables() we want to keep the entire
        // tables array together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
    
        // It's good practice to name the table and column definitions you
        // are getting - $table and $column don't cut it in more complex
        // modules
        $menuitems_table = $pntable['me_menuitems'];
        $menuitems_column = &$pntable['me_menuitems_column'];
    
        // Update the item - the formatting here is not mandatory, but it does
        // make the SQL statement relatively easy to read.  Also, separating
        // out the sql statement from the Execute() command allows for simpler
        // debug operation if it is ever needed
        $sql  = "UPDATE $menuitems_table ";
        $sql .= "SET $menuitems_column[parent_id] = " . pnVarPrepForStore($parent_id) . ", ";
        $sql .= "    $menuitems_column[block_id] = " . pnVarPrepForStore($bid) . ", ";
        $sql .= "    $menuitems_column[language] = '" . pnVarPrepForStore($language) . "', ";
        $sql .= "    $menuitems_column[title] = '" . pnVarPrepForStore($title) . "', ";
        $sql .= "    $menuitems_column[menutype] = " . pnVarPrepForStore($menutype) . ", ";
        $sql .= "    $menuitems_column[newwindow] = " . pnVarPrepForStore($newwindow) . ", ";
        $sql .= "    $menuitems_column[uri] = '" . pnVarPrepForStore($uri) . "', ";
        $sql .= "    $menuitems_column[start_date] = '" . pnVarPrepForStore($start_date) . "', ";
        $sql .= "    $menuitems_column[end_date] = '" . pnVarPrepForStore($end_date) . "', ";
        $sql .= "    $menuitems_column[status] = '" . pnVarPrepForStore($status) . "',";
        if( $rollover_img1_name != "" ) {
            $sql .= "$menuitems_column[rollover_img1_file] = '".pnVarPrepForStore( $rollover_img1_file )."', ";
            $sql .= "$menuitems_column[rollover_img1_size] = '".pnVarPrepForStore( $rollover_img1_size )."', ";
            $sql .= "$menuitems_column[rollover_img1_type] = '".pnVarPrepForStore( $rollover_img1_type )."', ";
            $sql .= "$menuitems_column[rollover_img1] = '".pnVarPrepForStore( $rollover_img1 )."', ";
        } else if( $rollover_img1_del ) {
            $sql .= "$menuitems_column[rollover_img1_file] = '', ";
            $sql .= "$menuitems_column[rollover_img1_size] = '0', ";
            $sql .= "$menuitems_column[rollover_img1_type] = '', ";
            $sql .= "$menuitems_column[rollover_img1] = '', ";
        }

        if( $rollover_img2_name != "" ) {
            $sql .= "$menuitems_column[rollover_img2_file] = '".pnVarPrepForStore( $rollover_img2_file )."', ";
            $sql .= "$menuitems_column[rollover_img2_size] = '".pnVarPrepForStore( $rollover_img2_size )."', ";
            $sql .= "$menuitems_column[rollover_img2_type] = '".pnVarPrepForStore( $rollover_img2_type )."', ";
            $sql .= "$menuitems_column[rollover_img2] = '".pnVarPrepForStore( $rollover_img2 )."', ";
        } else if( $rollover_img2_del ) {
            $sql .= "$menuitems_column[rollover_img2_file] = '', ";
            $sql .= "$menuitems_column[rollover_img2_size] = '0', ";
            $sql .= "$menuitems_column[rollover_img2_type] = '', ";
            $sql .= "$menuitems_column[rollover_img2] = '', ";
        }

        if( $bg_img_name != "" ) {
            $sql .= "$menuitems_column[bg_img_file] = '".pnVarPrepForStore( $bg_img_file )."', ";
            $sql .= "$menuitems_column[bg_img_size] = '".pnVarPrepForStore( $bg_img_size )."', ";
            $sql .= "$menuitems_column[bg_img_type] = '".pnVarPrepForStore( $bg_img_type )."', ";
            $sql .= "$menuitems_column[bg_img] = '".pnVarPrepForStore( $bg_img )."', ";
        } else if( $bg_img_del ) {
            $sql .= "$menuitems_column[bg_img_file] = '', ";
            $sql .= "$menuitems_column[bg_img_size] = '0', ";
            $sql .= "$menuitems_column[bg_img_type] = '', ";
            $sql .= "$menuitems_column[bg_img] = '', ";
        }

        $sql .= "$menuitems_column[weight] = " . pnVarPrepForStore($weight);
        $sql .= " WHERE $menuitems_column[id] = " . pnVarPrepForStore($meid);
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _UPDATEFAILED);
            return false;
        }
    
        // Let the calling process know that we have finished successfully
        return true;
    }

    function api_qupdate( $args )
    {
        // Get arguments from argument array - all arguments to this function
        // should be obtained from the $args array, getting them from other
        // places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        extract($args);
    
        // Argument check - make sure that all required arguments are present,
        // if not then set an appropriate error message and return
        if ((!isset($meid)) || (!isset($task))) {
            pnSessionSetVar('errormsg', _MODARGSERROR);
            return false;
        }
    
        if( empty( $pid )) { $pid = -1; }
    
        // Load API.  Note that this is loading the user API in addition to
        // the administration API, that is because the user API contains
        // the function to obtain item information which is the first thing
        // that we need to do.  If the API fails to load an appropriate error
        // message is posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'user')) {
            pnSessionSetVar('errormsg', _LOADFAILED.":ME:api_qupdate");
            return false;
        }
    
        // The user API function is called.  This takes the item ID which
        // we obtained from the input and gets us the information on the
        // appropriate item.  If the item does not exist we post an appropriate
        // message and return
        $item = pnModAPIFunc('ContentExpress',
                'user',
                'get_menuitem',
                array('meid' => $meid ));
    
        if ($item == false) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOSUCHITEM);
            return false;
        }
    
        $pitem = false;
        if( $pid > -1 ) {
            $pitem = pnModAPIFunc('ContentExpress',
                                  'user',
                                  'get_menuitem',
                                  array('meid' => $pid ));
            if( $pitem == false ) {
                pnSessionSetVar('errormsg', _MENUCONTENTNOSUCHITEM);
                return false;
            }
        }
    
        // Security check - important to do this as early on as possible to 
        // avoid potential security holes or just too much wasted processing.
        // However, in this case we had to wait until we could obtain the item
        // name to complete the instance information so this is the first
        // chance we get to do the check
    
        // Note that at this stage we have two sets of item information, the
        // pre-modification and the post-modification.  We need to check against
        // both of these to ensure that whoever is doing the modification has
        // suitable permissions to edit the item otherwise people can potentially
        // edit areas to which they do not have suitable access
        if (!pnSecAuthAction(0, 'MenuExpress::Menu', ":$item[title]:$meid", ACCESS_EDIT)) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOAUTH);
            return false;
        }
    
        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn()
        // we currently just want the first item, which is the official
        // database handle.  For pnDBGetTables() we want to keep the entire
        // tables array together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
    
        // It's good practice to name the table and column definitions you
        // are getting - $table and $column don't cut it in more complex
        // modules
        $contentitems_table = $pntable['me_contentitems'];
        $contentitems_column = &$pntable['me_contentitems_column'];
    
        $menuitems_table = $pntable['me_menuitems'];
        $menuitems_column = &$pntable['me_menuitems_column'];
    
        // Update the item - the formatting here is not mandatory, but it does
        // make the SQL statement relatively easy to read.  Also, separating
        // out the sql statement from the Execute() command allows for simpler
        // debug operation if it is ever needed
        $sql = "";
        if( $task == 'left' ) {
            list($weight1,$weight2) = CommonExpress_calculate_weight( $dbconn, $pntable, "menu", $task, $meid, $pid );
            $sql .= "UPDATE $menuitems_table ";
            $sql .= "SET $menuitems_column[parent_id] = '" . pnVarPrepForStore($pitem['parent_id']) . "', ";
            $sql .= "    $menuitems_column[weight] = " . pnVarPrepForStore($weight1) . " ";
            $sql .= "WHERE $menuitems_column[id] = " . pnVarPrepForStore($meid);
        }
        else if( $task == 'right' ) {
            list($weight1,$weight2) = CommonExpress_calculate_weight( $dbconn, $pntable, "menu", $task, $meid, $pid );
            $sql .= "UPDATE $menuitems_table ";
            $sql .= "SET $menuitems_column[parent_id] = '" . pnVarPrepForStore($pid) . "', ";
            $sql .= "    $menuitems_column[weight] = " . pnVarPrepForStore($weight1) . " ";
            $sql .= "WHERE $menuitems_column[id] = " . pnVarPrepForStore($meid);
        }
        else if( $task == 'up' ) {
            list($weight1,$weight2) = CommonExpress_calculate_weight( $dbconn, $pntable, "menu", $task, $meid, $pid );
            $sql .= "UPDATE $menuitems_table ";
            $sql .= "SET $menuitems_column[weight] = '" . pnVarPrepForStore($weight1) . "' ";
            $sql .= "WHERE $menuitems_column[id] = " . pnVarPrepForStore($meid);

            $dbconn->Execute($sql);
    
            // Check for an error with the database code, and if so set an
            // appropriate error message and return
            if ($dbconn->ErrorNo() != 0) {
                pnSessionSetVar('errormsg', _UPDATEFAILED);
                return false;
            }
    
            $sql = "UPDATE $menuitems_table ";
            $sql .= "SET $menuitems_column[weight] = '" . pnVarPrepForStore($weight2) . "' ";
            $sql .= "WHERE $menuitems_column[id] = " . pnVarPrepForStore($pid);
        }
        else if( $task == 'down' ) {
            list($weight1,$weight2) = CommonExpress_calculate_weight( $dbconn, $pntable, "menu", $task, $meid, $pid );

            $sql .= "UPDATE $menuitems_table ";
            $sql .= "SET $menuitems_column[weight] = '" . pnVarPrepForStore($weight2) . "' ";
            $sql .= "WHERE $menuitems_column[id] = " . pnVarPrepForStore($meid);

            $dbconn->Execute($sql);
    
            // Check for an error with the database code, and if so set an
            // appropriate error message and return
            if ($dbconn->ErrorNo() != 0) {
                pnSessionSetVar('errormsg', _UPDATEFAILED);
                return false;
            }
    
            $sql = "UPDATE $menuitems_table ";
            $sql .= "SET $menuitems_column[weight] = '" . pnVarPrepForStore($weight1) . "' ";
            $sql .= "WHERE $menuitems_column[id] = " . pnVarPrepForStore($pid);

        }
        else if( $task == 'act' ) {
            $status = 2;
            $sql .= "UPDATE $menuitems_table ";
            $sql .= "SET $menuitems_column[status] = '" . pnVarPrepForStore($status) . "' ";
            $sql .= "WHERE $menuitems_column[id] = " . pnVarPrepForStore($meid);
        }
        else if( $task == 'deact' ) {
            $status = 1;
            $sql .= "UPDATE $menuitems_table ";
            $sql .= "SET $menuitems_column[status] = '" . pnVarPrepForStore($status) . "' ";
            $sql .= "WHERE $menuitems_column[id] = " . pnVarPrepForStore($meid);
        } else {
            pnSessionSetVar('errormsg', _MODARGSERROR);
            return false;
        }
    
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _UPDATEFAILED);
            return false;
        }
    
        // Let the calling process know that we have finished successfully
        return true;
    }

    function api_getall( $args )
    {
        // Get arguments from argument array - all arguments to this function
        // should be obtained from the $args array, getting them from other places
        // such as the environment is not allowed, as that makes assumptions that
        // will not hold in future versions of PostNuke
        extract($args);
    
        $items = array();
    
        // Security check - important to do this as early on as possible to 
        // avoid potential security holes or just too much wasted processing
        if (!pnSecAuthAction(0, 'MenuExpress::Menu', '::', ACCESS_READ)) {
            return $items;
        }
    
        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn() we
        // currently just want the first item, which is the official database
        // handle.  For pnDBGetTables() we want to keep the entire tables array
        // together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
        $currlang = pnUserGetLang();
    
        // It's good practice to name the table and column definitions you are
        // getting - $table and $column don't cut it in more complex modules
        $menuitems_table = $pntable['me_menuitems'];
        $menuitems_column = &$pntable['me_menuitems_column'];
    
        // Get items - the formatting here is not mandatory, but it does make the
        // SQL statement relatively easy to read.  Also, separating out the sql
        // statement from the SelectLimit() command allows for simpler debug
        // operation if it is ever needed
        $sql  = "SELECT $menuitems_column[id], ";
        $sql .= "       $menuitems_column[parent_id], ";
        $sql .= "       $menuitems_column[block_id], ";
        $sql .= "       $menuitems_column[language], ";
        $sql .= "       $menuitems_column[title], ";
        $sql .= "       $menuitems_column[menutype], ";
        $sql .= "       $menuitems_column[newwindow], ";
        $sql .= "       $menuitems_column[uri], ";
        $sql .= "       $menuitems_column[start_date], ";
        $sql .= "       $menuitems_column[end_date], ";
        $sql .= "       $menuitems_column[status], ";
        $sql .= "       $menuitems_column[weight], ";
        $sql .= "       $menuitems_column[rollover_img1_file], ";
        $sql .= "       $menuitems_column[rollover_img2_file], ";
        $sql .= "       $menuitems_column[bg_img_file], ";
        $sql .= "       $menuitems_column[rollover_img1_size], ";
        $sql .= "       $menuitems_column[rollover_img2_size], ";
        $sql .= "       $menuitems_column[bg_img_size], ";
        $sql .= "       $menuitems_column[rollover_img1_type], ";
        $sql .= "       $menuitems_column[rollover_img2_type], ";
        $sql .= "       $menuitems_column[bg_img_type] ";
        $sql .= "FROM $menuitems_table ";
        $sql .= "WHERE ($menuitems_column[language] = '" . pnVarPrepForStore($currlang) . "' OR ";
        $sql .= "      $menuitems_column[language] = '' OR ";
        $sql .= "      $menuitems_column[language] = 'x_all')";
        if( !empty( $bid ) && $bid > -1 ) {
            $sql .= " AND ( $menuitems_column[block_id] = $bid ";
            $sql .= " OR $menuitems_column[block_id] = -1 )";
        }

        // If current date is provided, then use it to restrict result set
        if( isset( $curr_date ) && !empty( $curr_date )) {
            $sql .= " AND $menuitems_column[start_date] <= '".pnVarPrepForStore($curr_date)."'";
            $sql .= " AND '".pnVarPrepForStore($curr_date)."' <= $menuitems_column[end_date] ";
        }

        // If current status is provided, then use it to restrict result set
        if( isset( $curr_status ) && !empty( $curr_status )) {
            $sql .= " AND $menuitems_column[status] = ".pnVarPrepForStore($curr_status);
        }

        $sql .= " ORDER BY $menuitems_column[block_id], ";
        $sql .= "        $menuitems_column[parent_id], ";
        $sql .= "        $menuitems_column[weight]";
        $result = $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an appropriate
        // error message and return
        if ($dbconn->ErrorNo() != 0) {
            // Since there can be time where there is nothing in the table
            // pnSessionSetVar('errormsg', _GETFAILED);
            return $items;
        }
    
        // Put items into result array.  Note that each item is checked
        // individually to ensure that the user is allowed access to it before it
        // is added to the results array
        for (; !$result->EOF; $result->MoveNext()) {
            list($id, $parent_id, $block_id, $language, $title, $menutype, $newwindow, $uri,
                 $start_date, $end_date, $status, $weight,
                 $rollover_img1_file, $rollover_img2_file, $bg_img_file,
                 $rollover_img1_size, $rollover_img2_size, $bg_img_size,
                 $rollover_img1_type, $rollover_img2_type, $bg_img_type) = $result->fields;

            // Comment this out to reduce SQL query calls. Thanks to Iassen Manov
            //$block = CommonExpress_getblock( pnModGetIDFromName('ContentExpress'), $bid );
            //if (pnSecAuthAction(0, 'MenuExpress::Menu', "$block[title]:$title:$id", ACCESS_READ) ||
            if( pnSecAuthAction( 0, 'MenuExpress::Menu', "$bid:$title:$id", ACCESS_READ )) {
                $items[] = array('id' => $id,
                                 'parent_id' => $parent_id,
                                 'bid' => $block_id,
                                 'language' => $language,
                                 'title' => $title,
                                 'menutype' => $menutype,
                                 'newwindow' => $newwindow,
                                 'uri' => $uri,
                                 'start_date' => $start_date,
                                 'end_date' => $end_date,
                                 'status' => $status,
                                 'weight' => $weight,
                                 'rollover_img1_file' => $rollover_img1_file,
                                 'rollover_img2_file' => $rollover_img2_file,
                                 'bg_img_file' => $bg_img_file,
                                 'rollover_img1_size' => $rollover_img1_size,
                                 'rollover_img2_size' => $rollover_img2_size,
                                 'bg_img_size' => $bg_img_size,
                                 'rollover_img1_type' => $rollover_img1_type,
                                 'rollover_img2_type' => $rollover_img2_type,
                                 'bg_img_type' => $bg_img_type
                           );
            }
        }
    
        // All successful database queries produce a result set, and that result
        // set should be closed when it has been finished with
        $result->Close();
    
        // Return the items
        return $items;
    }

    function api_get( $args )
    {
        // Get arguments from argument array - all arguments to this function
        // should be obtained from the $args array, getting them from other places
        // such as the environment is not allowed, as that makes assumptions that
        // will not hold in future versions of PostNuke
        extract($args);
    
        // Argument check - make sure that all required arguments are present, if
        // not then set an appropriate error message and return
        if (!isset($meid)) {
            pnSessionSetVar('errormsg', _MODARGSERROR);
            return false;
        }
    
        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn() we
        // currently just want the first item, which is the official database
        // handle.  For pnDBGetTables() we want to keep the entire tables array
        // together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
    
        // It's good practice to name the table and column definitions you are
        // getting - $table and $column don't cut it in more complex modules
        $menuitems_table = $pntable['me_menuitems'];
        $menuitems_column = &$pntable['me_menuitems_column'];
    
        // Get item - the formatting here is not mandatory, but it does make the
        // SQL statement relatively easy to read.  Also, separating out the sql
        // statement from the Execute() command allows for simpler debug operation
        // if it is ever needed
        $sql  = "SELECT ";
        $sql .= "      $menuitems_column[parent_id], ";
        $sql .= "      $menuitems_column[block_id], ";
        $sql .= "      $menuitems_column[language], ";
        $sql .= "      $menuitems_column[title], ";
        $sql .= "      $menuitems_column[menutype], ";
        $sql .= "      $menuitems_column[newwindow], ";
        $sql .= "      $menuitems_column[uri], ";
        $sql .= "      $menuitems_column[start_date], ";
        $sql .= "      $menuitems_column[end_date], ";
        $sql .= "      $menuitems_column[status], ";
        $sql .= "      $menuitems_column[weight], ";
        $sql .= "      $menuitems_column[rollover_img1], ";
        $sql .= "      $menuitems_column[rollover_img2], ";
        $sql .= "      $menuitems_column[bg_img], ";
        $sql .= "      $menuitems_column[rollover_img1_file], ";
        $sql .= "      $menuitems_column[rollover_img2_file], ";
        $sql .= "      $menuitems_column[bg_img_file], ";
        $sql .= "      $menuitems_column[rollover_img1_size], ";
        $sql .= "      $menuitems_column[rollover_img2_size], ";
        $sql .= "      $menuitems_column[bg_img_size], ";
        $sql .= "      $menuitems_column[rollover_img1_type], ";
        $sql .= "      $menuitems_column[rollover_img2_type], ";
        $sql .= "      $menuitems_column[bg_img_type] ";
        $sql .= "FROM $menuitems_table ";
        $sql .= "WHERE $menuitems_column[id] = " . pnVarPrepForStore($meid);

        // If current date is provided, then use it to restrict result set
        if( isset( $curr_date ) && !empty( $curr_date )) {
            $sql .= " AND $menuitems_column[start_date] <= '".pnVarPrepForStore($curr_date)."' ";
            $sql .= " AND '".pnVarPrepForStore($curr_date)."' <= $menuitems_column[end_date]";
        }

        // If current status is provided, then use it to restrict result set
        if( isset( $curr_status ) && !empty( $curr_status )) {
            $sql .= " AND $menuitems_column[status] = ".pnVarPrepForStore($curr_status);
        }

        $result = $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an appropriate
        // error message and return
        if ($dbconn->ErrorNo() != 0) {
            return false;
        }
    
        // Check for no rows found, and if so return
        if ($result->EOF) {
            return false;
        }
    
        // Obtain the item information from the result set
        list($parent_id, $bid, $language, $title, $menutype, $newwindow, $uri,
             $start_date, $end_date, $status, $weight,
             $rollover_img1, $rollover_img2, $bg_img,
             $rollover_img1_file, $rollover_img2_file, $bg_img_file,
             $rollover_img1_size, $rollover_img2_size, $bg_img_size,
             $rollover_img1_type, $rollover_img2_type, $bg_img_type) = $result->fields;
    
        // All successful database queries produce a result set, and that result
        // set should be closed when it has been finished with
        $result->Close();
    
        // Security check - important to do this as early on as possible to avoid
        // potential security holes or just too much wasted processing.  Although
        // this one is a bit late in the function it is as early as we can do it as
        // this is the first time we have the relevant information
        $block = CommonExpress_getblock( pnModGetIDFromName('ContentExpress'), $bid );

        if (!pnSecAuthAction(0, 'MenuExpress::Menu', "$block[title]:$title:$meid", ACCESS_READ) &&
            !pnSecAuthAction(0, 'MenuExpress::Menu', "$block[bid]:$title:$meid", ACCESS_READ)) {
            return false;
        }
    
        // Create the item array
        $item = array('id' => $meid,
                      'parent_id' => $parent_id,
                      'bid' => $bid,
                      'language' => $language,
                      'title' => $title,
                      'menutype' => $menutype,
                      'newwindow' => $newwindow,
                      'uri' => $uri,
                      'start_date' => $start_date,
                      'end_date' => $end_date,
                      'status' => $status,
                      'weight' => $weight,
                      'rollover_img1' => $rollover_img1,
                      'rollover_img2' => $rollover_img2,
                      'bg_img' => $bg_img,
                      'rollover_img1_file' => $rollover_img1_file,
                      'rollover_img2_file' => $rollover_img2_file,
                      'bg_img_file' => $bg_img_file,
                      'rollover_img1_size' => $rollover_img1_size,
                      'rollover_img2_size' => $rollover_img2_size,
                      'bg_img_size' => $bg_img_size,
                      'rollover_img1_type' => $rollover_img1_type,
                      'rollover_img2_type' => $rollover_img2_type,
                      'bg_img_type' => $bg_img_type
                );
    
        // Return the item array
        return $item;
    }
    
    function admin_new()
    {
        // Create output object - this object will store all of our output so that
        // we can return it easily when required
        $output = new pnHTML();
        list($bid, $btitle) = pnVarCleanFromInput('bid','btitle');
    
        // Security check - important to do this as early as possible to avoid
        // potential security holes or just too much wasted processing
        if (!pnSecAuthAction(0, 'MenuExpress::Menu', '::', ACCESS_ADD)) {
            $output->Text(_MENUCONTENTNOAUTH);
            return $output->GetOutput();
        }
        $currlang = pnUserGetLang();
        $blocks = CommonExpress_getallblocks( pnModGetIDFromName('ContentExpress'), array( "jsmenu", "menu" ), $currlang );
        $blockitem = 0; // default value means no block specified
        // Get block item by block id
        if ( !empty( $bid ) && is_array( $blocks )) {  
	    $blk = array_values($blocks);
            foreach ($blk as $blkitem) {
                if ( $blkitem['bid'] == $bid ) { 
                    $blockitem = $blkitem;
                }
            }
        }  
 
        // Add menu to output - it helps if all of the module pages have a standard
        // menu at their head to aid in navigation
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        // Admin Menu
        $output->Text(pnModFunc('ContentExpress', 'admin', 'adminmenu'));
        // Menu block select box
        $output->Text($this->admin_menublock_select_form(_MENUCONTENTSELECTBLOCK,$blocks,$blockitem  ));  
        $output->Text($this->admin_view( array('bid' => $blockitem['bid'], 'action' => "newmenu")));
        $output->Linebreak();
        // Add new menu form 
        $output->Text($this->admin_build_form( _MENUCONTENTADDMENU, _MENUCONTENTSAVEMENU, 0, $blockitem) );
        $output->TableStart( );
        // Get module information for footer
        $modinfo = pnModGetInfo(pnModGetIDFromName('ContentExpress'));

        $output->TableRowStart();
        $output->TableColStart( 1, 'left' );
        ContentExpress_footer( $output, $modinfo );
        $output->TableColEnd();
        $output->TableRowEnd();
        $output->TableEnd();

        $output->SetInputMode(_PNH_PARSEINPUT);
    
        // Return the output that has been generated by this function
        return $output->GetOutput();
    }

    function admin_create( $args )
    {
        // Get parameters from whatever input we need.  All arguments to this
        // function should be obtained from pnVarCleanFromInput(), getting them
        // from other places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        list($parent_id, $bid, $language, $title, $menutype, $newwindow, $moduri,
             $uri, $start_date, $end_date, $status, $weight,
             $rollover_img1, $rollover_img2, $bg_img,
             $rollover_img1_name, $rollover_img2_name, $bg_img_name,
             $rollover_img1_type, $rollover_img2_type, $bg_img_type,
             $rollover_img1_size, $rollover_img2_size, $bg_img_size,
             $rollover_img1_file, $rollover_img2_file, $bg_img_file ) =
        pnVarCleanFromInput('parent_id', 'bid', 'language', 'title', 'menutype', 'newwindow', 'moduri',
                            'uri', 'start_date', 'end_date', 'status', 'weight',
                            'rollover_img1', 'rollover_img2', 'bg_img',
                            'rollover_img1_name', 'rollover_img2_name', 'bg_img_name',
                            'rollover_img1_type', 'rollover_img2_type', 'bg_img_type',
                            'rollover_img1_size', 'rollover_img2_size', 'bg_img_size',
                            'rollover_img1_file', 'rollover_img2_file', 'bg_img_file');
    
        // Admin functions of this type can be called by other modules.  If this
        // happens then the calling module will be able to pass in arguments to
        // this function through the $args parameter.  Hence we extract these
        // arguments *after* we have obtained any form-based input through
        // pnVarCleanFromInput().
        extract($args);
    
        if( $menutype == 1 || $menutype == 2 ) {
            $uri = "";
        } else if( $menutype == 3 ) {
            $uri = trim( $moduri );
        } else if( $menutype == 5 ) {
            // Great idea contributed by tsilihin
            $uri = "#onclick=if(location.href.indexOf('?')=='-1'){this.id='?'+this.id.substring (1,this.id.length);};location.href=location.href.replace(/\?meid=\d+|&m eid=\d+/gi,'')+this.id; id=";
        }

        // Confirm authorisation code.  This checks that the form had a valid
        // authorisation code attached to it.  If it did not then the function will
        // proceed no further as it is possible that this is an attempt at sending
        // in false data to the system
        if (!pnSecConfirmAuthKey()) {
            pnSessionSetVar('errormsg', _BADAUTHKEY);
            pnRedirect(pnModURL('ContentExpress', 'admin', 'newmenu'));
            return true;
        }
    
        // Need to make sure menu title is not missing
        if( strlen( trim( $title )) == 0 && $menutype != 1 ) {
            pnSessionSetVar('errormsg', _MENUCONTENTMISSINGNAME);
            pnRedirect(pnModURL('ContentExpress', 'admin', 'newmenu'));
            return true;
        }
    
        // Need to make sure uri is not empty if menu item are not of type 1 or 2
        if(( $menutype == 3 || $menutype == 4 ) && $uri == "" ) {
            pnSessionSetVar('errormsg', _MENUCONTENTMISSINGURI);
            pnRedirect(pnModURL('ContentExpress', 'admin', 'newmenu'));
            return true;
        }

        // Notable by its absence there is no security check here.  This is because
        // the security check is carried out within the API function and as such we
        // do not duplicate the work here
    
        // Load API.  All of the actual work for the creation of the new item is
        // done within the API, so we need to load that in before we can do
        // anything.  If the API fails to load an appropriate error message is
        // posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'admin')) {
            pnSessionSetVar('errormsg', _LOADFAILED.":ME:admin_create");
            return $output->GetOutput();
        }
    
        // Process the menu item images if applicable
        // Process the temp file and move them to the cache directory and then
        // rename the filename variable to the cached file.
        if( is_array( $rollover_img1 )) {
            $rollover_img1_name = $rollover_img1['name'];
            $rollover_img1_type = $rollover_img1['type'];
            $rollover_img1_size = $rollover_img1['size'];
            $rollover_img1_file = $rollover_img1['tmp_name'];
        } else {
            $rollover_img1_file = $rollover_img1;
        }
        if( is_uploaded_file( $rollover_img1_file )) {
            $cache_file = "modules/ContentExpress/pncache/$rollover_img1_name";
            if( !move_uploaded_file( $rollover_img1_file, $cache_file )) {
                pnSessionSetVar( 'errormsg', _MENUCONTENTIMGCOPYFAILED );
                return false;
            }
            chmod( $cache_file, 0644 );
            $rollover_img1_file = $cache_file;
        }

        if( is_array( $rollover_img2 )) {
            $rollover_img2_name = $rollover_img2['name'];
            $rollover_img2_type = $rollover_img2['type'];
            $rollover_img2_size = $rollover_img2['size'];
            $rollover_img2_file = $rollover_img2['tmp_name'];
        } else {
            $rollover_img2_file = $rollover_img2;
        }
        if( is_uploaded_file( $rollover_img2_file )) {
            $cache_file = "modules/ContentExpress/pncache/$rollover_img2_name";
            if( !move_uploaded_file( $rollover_img2_file, $cache_file )) {
                pnSessionSetVar( 'errormsg', _MENUCONTENTIMGCOPYFAILED );
                return false;
            }
            chmod( $cache_file, 0644 );
            $rollover_img2_file = $cache_file;
        }

        if( is_array( $bg_img )) {
            $bg_img_name = $bg_img['name'];
            $bg_img_type = $bg_img['type'];
            $bg_img_size = $bg_img['size'];
            $bg_img_file = $bg_img['tmp_name'];
        } else {
            $bg_img_file = $bg_img;
        }
        if( is_uploaded_file( $bg_img_file )) {
            $cache_file = "modules/ContentExpress/pncache/$bg_img_name";
            if( !move_uploaded_file( $bg_img_file, $cache_file )) {
                pnSessionSetVar( 'errormsg', _MENUCONTENTIMGCOPYFAILED );
                return false;
            }
            chmod( $cache_file, 0644 );
            $bg_img_file = $cache_file;
        }

        // Load the content of the image files into the variables
        $rollover_img1 = null;
        if( strlen( trim( $rollover_img1_file )) > 0 ) {
            $fh = @fopen( $rollover_img1_file, "rb" );
            $fsize = @filesize( $rollover_img1_file );
            $rollover_img1 = fread( $fh, $fsize );
            fclose( $fh );
        }

        $rollover_img2 = null;
        if( strlen( trim( $rollover_img2_file )) > 0 ) {
            $fh = @fopen( $rollover_img2_file, "rb" );
            $fsize = @filesize( $rollover_img2_file );
            $rollover_img2 = fread( $fh, $fsize );
            fclose( $fh );
        }

        $bg_img = null;
        if( strlen( trim( $bg_img_file )) > 0 ) {
            $fh = @fopen( $bg_img_file, "rb" );
            $fsize = @filesize( $bg_img_file );
            $bg_img = fread( $fh, $fsize );
            fclose( $fh );
        }

        // The API function is called.  Note that the name of the API function and
        // the name of this function are identical, this helps a lot when
        // programming more complex modules.  The arguments to the function are
        // passed in as their own arguments array
        $id = pnModAPIFunc('ContentExpress',
                           'admin',
                           'createmenu',
                           array(
                                 'parent_id' => $parent_id,
                                 'bid' => $bid,
                                 'language' => $language,
                                 'title' => $title,
                                 'menutype' => $menutype,
                                 'newwindow' => $newwindow,
                                 'uri' => $uri,
                                 'start_date' => $start_date,
                                 'end_date' => $end_date,
                                 'status' => $status,
                                 'weight' => $weight,
                                 'rollover_img1_name' => $rollover_img1_name,
                                 'rollover_img1_type' => $rollover_img1_type,
                                 'rollover_img1_size' => $rollover_img1_size,
                                 'rollover_img1_file' => $rollover_img1_file,
                                 'rollover_img1' => $rollover_img1,
                                 'rollover_img2_name' => $rollover_img2_name,
                                 'rollover_img2_type' => $rollover_img2_type,
                                 'rollover_img2_size' => $rollover_img2_size,
                                 'rollover_img2_file' => $rollover_img2_file,
                                 'rollover_img2' => $rollover_img2,
                                 'bg_img_name' => $bg_img_name,
                                 'bg_img_type' => $bg_img_type,
                                 'bg_img_size' => $bg_img_size,
                                 'bg_img_file' => $bg_img_file,
                                 'bg_img' => $bg_img
                           ));
    
        // The return value of the function is checked here, and if the function
        // suceeded then an appropriate message is posted.  Note that if the
        // function did not succeed then the API function should have already
        // posted a failure message so no action is required
        if ($id != false) {
            // Success
            pnSessionSetVar('statusmsg', _MENUCONTENTMENUCREATED);
        }

        // Check to see if the cache file for Javascript menu block exist,
        // if so, remove the file and let display to recreate one to reflect new changes
        $cache = "modules/ContentExpress/pncache/jsmenu_$bid.js";

        if( file_exists( $cache )) {
            unlink( $cache );
        }
    
        // This function generated no output, and so now it is complete we redirect
        // the user to an appropriate page for them to carry on their work
        pnRedirect(pnModURL('ContentExpress', 'admin', 'newmenu'));
    
        // Return
        return true;
    }

    function admin_edit( $args )
    {
        // Get parameters from whatever input we need.  All arguments to this
        // function should be obtained from pnVarCleanFromInput(), getting them
        // from other places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        list($bid, $btitle, $meid, $objectid)= pnVarCleanFromInput('bid', 'btitle', 'meid', 'objectid');
    
                               
        // Admin functions of this type can be called by other modules.  If this
        // happens then the calling module will be able to pass in arguments to
        // this function through the $args parameter.  Hence we extract these
        // arguments *after* we have obtained any form-based input through
        // pnVarCleanFromInput().
        extract($args);

        // At this stage we check to see if we have been passed $objectid, the
        // generic item identifier.  This could have been passed in by a hook or
        // through some other function calling this as part of a larger module, but
        // if it exists it overrides $tid
        //
        // Note that this module couuld just use $objectid everywhere to avoid all
        // of this munging of variables, but then the resultant code is less
        // descriptive, especially where multiple objects are being used.  The
        // decision of which of these ways to go is up to the module developer
        if (!empty($objectid)) {
            $meid = $objectid;
        }                       
    
        // Create output object - this object will store all of our output so that
        // we can return it easily when required
        $output = new pnHTML();
    
        // Load API.  Note that this is loading the user API, that is because the
        // user API contains the function to obtain item information which is the
        // first thing that we need to do.  If the API fails to load an appropriate
        // error message is posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'user')) {
            $output->Text(_LOADFAILED.":ME:admin_edit");
            return $output->GetOutput();
        }
    
        // The user API function is called.  This takes the item ID which we
        // obtained from the input and gets us the information on the appropriate
        // item.  If the item does not exist we post an appropriate message and
        // return
        $currlang = pnUserGetLang();
        $blocks = CommonExpress_getallblocks( pnModGetIDFromName('ContentExpress'), array( "jsmenu", "menu"), $currlang );

        $blockitem = 0; // default value means no block specified
        // Get block item by block id
        if( is_array( $blocks )) {  
	    $blk = array_values($blocks);
            if( is_array( $blk )) {
                foreach ($blk as $blkitem) {
                    if ( $blkitem['bid'] == $bid ) { 
                        $blockitem = $blkitem;
                        break;
                    }
                }
            }
        }  

        $item = pnModAPIFunc('ContentExpress',
                             'user',
                             'get_menuitem',
                             array('meid' => $meid));
    
        if ($item == false) {
            $output->Text(_MENUCONTENTNOSUCHITEM);
            return $output->GetOutput();
        }
    
        // Insert field id with value of $meid, so we don't need yet another argument
        // for admin_build_form()
        $item['id'] = $meid;
    
        // Security check - important to do this as early as possible to avoid
        // potential security holes or just too much wasted processing.  However,
        // in this case we had to wait until we could obtain the item name to
        // complete the instance information so this is the first chance we get to
        // do the check
        if (!pnSecAuthAction(0, 'MenuExpress::Menu', "$btitle:$item[title]:$meid", ACCESS_EDIT) &&
            !pnSecAuthAction(0, 'MenuExpress::Menu', "$bid:$item[title]:$meid", ACCESS_EDIT)) {
            $output->Text(_MENUCONTENTNOAUTH);
            return $output->GetOutput();
        }
        // Add menu to output - it helps if all of the module pages have a standard
        // menu at their head to aid in navigation
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text(pnModFunc('ContentExpress', 'admin', 'adminmenu'));
        // Menu block select box
        $output->Text($this->admin_menublock_select_form(_MENUCONTENTSELECTBLOCK,$blocks,$blockitem ));  

        $output->Text($this->admin_view( array('bid' => $blockitem['bid'], 'action' => "editmenu") ));
        $output->Linebreak();
        $output->Text($this->admin_build_form( _MENUCONTENTMENUEDIT, _MENUCONTENTUPDATEMENU, $item, $blockitem,
                                               array( 'bid' => $bid,
                                                      'btitle' => $btitle )));

        // Get module information for footer
        $modinfo = pnModGetInfo(pnModGetIDFromName('ContentExpress'));

        $output->TableStart( );
        $output->TableRowStart();
        $output->TableColStart( 1, 'left' );
        ContentExpress_footer( $output, $modinfo );
        $output->TableColEnd();
        $output->TableRowEnd();
        $output->TableEnd();

        $output->SetInputMode(_PNH_PARSEINPUT);
    
        // Return the output that has been generated by this function
        return $output->GetOutput();
    }

    function admin_view($args)
    {
        // Create output object - this object will store all of our output so that
        // we can return it easily when required
        $output = new pnHTML();
    
        if (!pnSecAuthAction(0, 'MenuExpress::Menu', '::', ACCESS_ADMIN)) {
            $output->Text(_MENUCONTENTNOAUTH);
            return $output->GetOutput();
        }
        $meid = pnVarCleanFromInput('meid');
        extract($args);

        if ( !isset( $meid ) ) {
             $meid = -1;
        }

        $output->SetOutputMode(_PNH_RETURNOUTPUT);
   
        // Load API.  Note that this is loading the user API, that is because the
        // user API contains the function to obtain item information which is the
        // first thing that we need to do.  If the API fails to load an appropriate
        // error message is posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'user')) {
            $output->Text(_LOADFAILED.":ME:admin_view");
            return $output->GetOutput();
        }
    
        // The user API function is called.  This takes the item ID which we
        // obtained from the input and gets us the information on the appropriate
        // item.  If the item does not exist we post an appropriate message and
        // return

        $items = pnModAPIFunc('ContentExpress',
                              'user',
                              'getall_menuitems',
                              array( 'bid' => $bid ));

    
        if ($items == false) {
            $output->Text(_MENUCONTENTNOSUCHITEM);
            return $output->GetOutput();
        }

        $btitles = CommonExpress_getallblockstitle();

        // Get the menu info
        $curr_meid = $meid;    
        $curr_bid = -1;

        // Built the menu tree
        $prev_pid = -1;
        $prev_weight_min = 999999999999;
        $prev_meid = -1;
        $menus = array();
        $weight = 0;
        foreach( $items as $item ) {
            $menu = "";
            $actions = array();
            $child = array();
            if( $prev_pid != $item['parent_id'] ) {
                $prev_pid = $item['parent_id'];
                $prev_weight_min = 999999999999;
                $weight = 0;
                $menus[$prev_meid]['actions'][7] = $output->Text( _MENUCONTENTMOVEDOWN );
            } else if( $prev_meid != -1 ) {
                $menus[$prev_meid]['actions'][7] = $output->URL(
                    pnModURL( "ContentExpress",
                              "admin",
                              "qupdmenu",
                              array( 'meid' => $prev_meid,
                                     'pid' => $item['id'],
                                     'bid' => $item['bid'], 
                                     'task' => 'down',
                                     'authid' => pnSecGenAuthKey() )),
                    _MENUCONTENTMOVEDOWN );
            }
    
            $actions[] = $output->URL(
                pnModURL( "ContentExpress", "admin", "editmenu",
                          array( 'meid' => $item['id'], 'bid' => $item['bid'] )),
                _MENUCONTENTEDIT );
            $actions[] = $output->URL(
                pnModURL( "ContentExpress", "admin", "delmenu",
                          array( 'meid' => $item['id'], 'bid' => $item['bid'] )),
                _MENUCONTENTDELETE );
    
            if( $item['status'] == 2 ) {
                $actions[] = $output->URL(
                    pnModURL( "ContentExpress", "admin", "qupdmenu",
                              array( 'meid' => $item['id'], 'bid' => $item['bid'], 'task' => 'deact', 'authid' => pnSecGenAuthKey() )),
                    _MENUCONTENTDEACTIVATE );
            } else {
                $actions[] = $output->URL(
                    pnModURL( "ContentExpress", "admin", "qupdmenu",
                              array( 'meid' => $item['id'], 'bid' => $item['bid'], 'task' => 'act', 'authid' => pnSecGenAuthKey() )),
                    _MENUCONTENTACTIVATE );
            }
    
            if( $item['parent_id'] != -1 ) {
                $actions[] = $output->URL(
                    pnModURL( "ContentExpress", "admin", "qupdmenu",
                              array( 'meid' => $item['id'], 'pid' => $item['parent_id'],
				     'bid' => $item['bid'],
                                     'task' => 'left', 'authid' => pnSecGenAuthKey() )),
                                        _MENUCONTENTMOVELEFT );
            } else {
                $actions[] = $output->Text( _MENUCONTENTMOVELEFT );
            }
            if( $prev_weight_min > $weight ) {
                $actions[] = $output->Text( _MENUCONTENTMOVERIGHT );
                $actions[] = $output->Text( _MENUCONTENTMOVEUP );
                $prev_weight_min = $weight;
            } else {
                $actions[] = $output->URL( pnModURL( "ContentExpress", "admin", "qupdmenu", array( 'meid' => $item['id'], 'pid' => $prev_meid, 'bid' => $item['bid'], 'task' => 'right', 'authid' => pnSecGenAuthKey() )),
                                        _MENUCONTENTMOVERIGHT );
                $actions[] = $output->URL( pnModURL( "ContentExpress", "admin", "qupdmenu", array( 'meid' => $item['id'], 'pid' => $prev_meid, 'bid' => $item['bid'], 'task' => 'up', 'authid' => pnSecGenAuthKey() )),
                                        _MENUCONTENTMOVEUP );
            }
    
            $menus[($item['id']+0)] = array( 'id'      => ($item['id']+0),
                                             'bid'     => $item['bid'],
					     'title'   => $item['title'],
                                             'actions' => $actions,
                                             'parent'  => ($item['parent_id']+0),
                                             'child'   => $child );
            $prev_meid = ($item['id']+0);
        }
        $menus[$prev_meid]['actions'][7] = $output->Text( _MENUCONTENTMOVEDOWN );
    
        foreach( $menus as $id => $menuitem ) {
            $parent_id = $menuitem['parent'];
            if( $parent_id > 0 && !empty( $menus[$parent_id] )) {
                // locates the parent and then updates its child list
                array_push( $menus[$parent_id]['child'], $id );
            }
        }
        // Expand all sibling menu items along the menu path 
        $menus2 = array();

        CommonExpress_build_dynitems_tree( $menus, $menus2, $curr_meid );

        // Start listing all menu items
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->TableStart( _MENUCONTENTVIEWMENUS );
        $output->TableRowStart();
        $output->TableColStart( 1, 'left' );
        $output->BoldText( _MENUCONTENTMENUNAME );
        $output->TableColEnd();
        $output->TableColStart( 1, 'left' );
        $output->BoldText( _MENUCONTENTMENUOPTIONS );
        $output->TableColEnd();
        $output->TableRowEnd();
        foreach( $menus2 as $id => $menuitem ) {
            
            if( $menuitem['parent'] == -1 ) {
                if( $curr_bid != $menuitem['bid'] ) {
                    $curr_bid = $menuitem['bid'];
                    $output->TableRowStart();
                    $output->TableColStart( 4, 'left' );
                    $output->BoldText( $btitles[$curr_bid]['title'] );
                    $output->TableColEnd();
                    $output->TableRowEnd();
                }
                CommonExpress_build_viewitems_tree( $output, "meid", $curr_meid, $menus2, $menuitem, $action );
            }
        }
        $output->TableEnd();
        $output->SetInputMode(_PNH_PARSEINPUT);
    
        // Return the output that has been generated by this function
        return $output->GetOutput();
    }

    function admin_update( $args )
    {
        // Get parameters from whatever input we need.  All arguments to this
        // function should be obtained from pnVarCleanFromInput(), getting them
        // from other places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        list($bid, $btitle, $meid, $objectid, $parent_id, $language, $title, $menutype,
             $newwindow, $moduri, $uri, $start_date, $end_date, $status, $weight,
             $rollover_img1, $rollover_img2, $bg_img,
             $rollover_img1_name, $rollover_img2_name, $bg_img_name,
             $rollover_img1_type, $rollover_img2_type, $bg_img_type,
             $rollover_img1_size, $rollover_img2_size, $bg_img_size,
             $rollover_img1_file, $rollover_img2_file, $bg_img_file,
             $rollover_img1_del, $rollover_img2_del, $bg_img_del ) =
            pnVarCleanFromInput('bid', 'btitle', 'meid', 'objectid', 'parent_id',
                                'language', 'title', 'menutype', 'newwindow', 'moduri', 'uri',
                                'start_date', 'end_date', 'status', 'weight',
                                'rollover_img1', 'rollover_img2', 'bg_img',
                                'rollover_img1_name', 'rollover_img2_name', 'bg_img_name',
                                'rollover_img1_type', 'rollover_img2_type', 'bg_img_type',
                                'rollover_img1_size', 'rollover_img2_size', 'bg_img_size',
                                'rollover_img1_file', 'rollover_img2_file', 'bg_img_file',
                                'rollover_img1_del', 'rollover_img2_del', 'bg_img_del');
    
        // User functions of this type can be called by other modules.  If this
        // happens then the calling module will be able to pass in arguments to
        // this function through the $args parameter.  Hence we extract these
        // arguments *after* we have obtained any form-based input through
        // pnVarCleanFromInput().
        extract($args);
                                
        // At this stage we check to see if we have been passed $objectid, the
        // generic item identifier.  This could have been passed in by a hook or
        // through some other function calling this as part of a larger module, but
        // if it exists it overrides $tid
        //
        // Note that this module couuld just use $objectid everywhere to avoid all
        // of this munging of variables, but then the resultant code is less
        // descriptive, especially where multiple objects are being used.  The
        // decision of which of these ways to go is up to the module developer
        if (!empty($objectid)) {
            $meid = $objectid;
        }                       
    
        if( $menutype == 1 || $menutype == 2 ) {
            $uri = "";
        } else if( $menutype == 3 ) {
            $uri = trim( $moduri );
        } else if( $menutype == 5 ) {
            // Great idea contributed by tsilihin
            $uri = "#onclick=if(location.href.indexOf('?')=='-1'){this.id='?'+this.id.substring (1,this.id.length);};location.href=location.href.replace(/\?meid=\d+|&m eid=\d+/gi,'')+this.id; id=";
        }
    
        // Confirm authorisation code.  This checks that the form had a valid
        // authorisation code attached to it.  If it did not then the function will
        // proceed no further as it is possible that this is an attempt at sending
        // in false data to the system
        if (!pnSecConfirmAuthKey()) {
            pnSessionSetVar('errormsg', _BADAUTHKEY);
            pnRedirect(pnModURL('ContentExpress', 'admin', 'editmenu',array('meid' => $meid, 'bid' => $bid) ));
            return true;
        }
    
        // Need to make sure menu title is not missing
        if( strlen( trim( $title )) == 0 && $menutype == 1 ) {
            pnSessionSetVar('errormsg', _MENUCONTENTMISSINGNAME);
            pnRedirect(pnModURL('ContentExpress', 'admin', 'editmenu',array('meid' => $meid, 'bid' => $bid) ));
            return true;
        }
    
        // Need to make sure the URI is not empty if menu item is not of type 1 or not of type 2
        if(( $menutype == 3 || $menutype == 4 ) && $uri == "" ) {
            pnSessionSetVar('errormsg', _MENUCONTENTMISSINGURI);
            pnRedirect(pnModURL('ContentExpress', 'admin', 'editmenu',array('meid' => $meid, 'bid' => $bid) ));
            return true;
        }

        // Notable by its absence there is no security check here.  This is because
        // the security check is carried out within the API function and as such we
        // do not duplicate the work here
    
        // Load API.  All of the actual work for the update of the new item is done
        // within the API, so we need to load that in before we can do anything.
        // If the API fails to load an appropriate error message is posted and the
        // function returns
        if (!pnModAPILoad('ContentExpress', 'admin')) {
            pnSessionSetVar('errormsg', _LOADFAILED.":ME:admin_update");
            return $output->GetOutput();
        }
    
        // Process the menu item images if applicable
        // Process the temp file and move them to the cache directory and then
        // rename the filename variable to the cached file.
        if( is_array( $rollover_img1 )) {
            $rollover_img1_name = $rollover_img1['name'];
            $rollover_img1_type = $rollover_img1['type'];
            $rollover_img1_size = $rollover_img1['size'];
            $rollover_img1_file = $rollover_img1['tmp_name'];
        } else if( $rollover_img1 != "" && $rollover_img1 != "none" ) {
            $rollover_img1_file = $rollover_img1;
        }

        if( is_array( $rollover_img2 )) {
            $rollover_img2_name = $rollover_img2['name'];
            $rollover_img2_type = $rollover_img2['type'];
            $rollover_img2_size = $rollover_img2['size'];
            $rollover_img2_file = $rollover_img2['tmp_name'];
        } else if( $rollover_img2 != "" && $rollover_img2 != "none" ) {
            $rollover_img2_file = $rollover_img2;
        }

        if( is_array( $bg_img )) {
            $bg_img_name = $bg_img['name'];
            $bg_img_type = $bg_img['type'];
            $bg_img_size = $bg_img['size'];
            $bg_img_file = $bg_img['tmp_name'];
        } else if( $bg_img != "" && $bg_img != "none" ) {
            $bg_img_file = $bg_img;
        }

        // Load the content of the image files into the variables only if the filename changed
        // We don't clean up the old file because we are not sure if other menu item is using the
        // same file. Clean up it up without knowing will cause major problem to the appearance
        // of the site. Site administrator should avoid using same file for menu items.
        // Disk space is cheap nowaday. :)
        if( strlen( trim( $rollover_img1_name )) > 0 ) {
            $fh = @fopen( $rollover_img1, "rb" );
            $fsize = @filesize( $rollover_img1 );
            $rollover_img1 = fread( $fh, $fsize );
            fclose( $fh );
        } else {
            $rollover_img1 = null;
        }

        if( strlen( trim( $rollover_img2_name )) > 0 ) {
            $fh = @fopen( $rollover_img2, "rb" );
            $fsize = @filesize( $rollover_img2);
            $rollover_img2 = fread( $fh, $fsize );
            fclose( $fh );
        } else {
            $rollover_img2 = null;
        }

        if( strlen( trim( $bg_img_name )) > 0 ) {
            $fh = @fopen( $bg_img, "rb" );
            $fsize = @filesize( $bg_img );
            $bg_img = fread( $fh, $fsize );
            fclose( $fh );
        } else {
            $bg_img = null;
        }

        // The API function is called.  Note that the name of the API function and
        // the name of this function are identical, this helps a lot when
        // programming more complex modules.  The arguments to the function are
        // passed in as their own arguments array.
        //
        // The return value of the function is checked here, and if the function
        // suceeded then an appropriate message is posted.  Note that if the
        // function did not succeed then the API function should have already
        // posted a failure message so no action is required
        if( pnModAPIFunc( 'ContentExpress',
                          'admin',
                          'updatemenu',
                          array('bid' => $bid,
                                'btitle' => $btitle,
                                'meid' => $meid,
                                'parent_id' => $parent_id,
                                'language' => $language,
                                'title' => $title,
                                'menutype' => $menutype,
                                'newwindow' => $newwindow,
                                'uri' => $uri,
                                'start_date' => $start_date,
                                'end_date' => $end_date,
                                'status' => $status,
                                'weight' => $weight,
                                'rollover_img1_name' => $rollover_img1_name,
                                'rollover_img1_type' => $rollover_img1_type,
                                'rollover_img1_size' => $rollover_img1_size,
                                'rollover_img1_file' => $rollover_img1_file,
                                'rollover_img1_del' => $rollover_img1_del,
                                'rollover_img1' => $rollover_img1,
                                'rollover_img2_name' => $rollover_img2_name,
                                'rollover_img2_type' => $rollover_img2_type,
                                'rollover_img2_size' => $rollover_img2_size,
                                'rollover_img2_file' => $rollover_img2_file,
                                'rollover_img2_del' => $rollover_img2_del,
                                'rollover_img2' => $rollover_img2,
                                'bg_img_name' => $bg_img_name,
                                'bg_img_type' => $bg_img_type,
                                'bg_img_size' => $bg_img_size,
                                'bg_img_file' => $bg_img_file,
                                'bg_img_del' => $bg_img_del,
                                'bg_img' => $bg_img
                          ))) {
            // Success
            pnSessionSetVar('statusmsg', _MENUCONTENTMENUUPDATED);
    
            // Check to see if the cache file for Javascript menu block exist,
            // if so, remove the file and let display to recreate one to reflect new changes
            $cache = "modules/ContentExpress/pncache/jsmenu_$bid.js";

            if( file_exists( $cache )) {
                unlink( $cache );
            }
        }

        // This function generated no output, and so now it is complete we redirect
        // the user to an appropriate page for them to carry on their work
        pnRedirect(pnModURL('ContentExpress', 'admin', 'editmenu', array('meid' => $meid, 'bid' => $bid)));
    
        // Return
        return true;
    }

    function admin_delete( $args )
    {
        // Get parameters from whatever input we need.  All arguments to this
        // function should be obtained from pnVarCleanFromInput(), getting them
        // from other places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        list($meid,
             $objectid,
             $confirmation) = pnVarCleanFromInput('meid',
                                                  'objectid',
                                                  'confirmation');
    
        // User functions of this type can be called by other modules.  If this
        // happens then the calling module will be able to pass in arguments to
        // this function through the $args parameter.  Hence we extract these
        // arguments *after* we have obtained any form-based input through
        // pnVarCleanFromInput().
        extract($args);
    
        // At this stage we check to see if we have been passed $objectid, the
        // generic item identifier.  This could have been passed in by a hook or
        // through some other function calling this as part of a larger module, but
        // if it exists it overrides $tid
        //
        // Note that this module couuld just use $objectid everywhere to avoid all
        // of this munging of variables, but then the resultant code is less
        // descriptive, especially where multiple objects are being used.  The
        // decision of which of these ways to go is up to the module developer
        if (!empty($objectid)) {
            $meid = $objectid;
        }                     
    
        // Create output object - this object will store all of our output so that
        // we can return it easily when required
        $output = new pnHTML();
    
        // Load API.  Note that this is loading the user API, that is because the
        // user API contains the function to obtain item information which is the
        // first thing that we need to do.  If the API fails to load an appropriate
        // error message is posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'user')) {
            $output->Text(_LOADFAILED.":ME:admin_delete");
            return $output->GetOutput();
        }
    
        // The user API function is called.  This takes the item ID which we
        // obtained from the input and gets us the information on the appropriate
        // item.  If the item does not exist we post an appropriate message and
        // return
        $item = pnModAPIFunc('ContentExpress',
                             'user',
                             'get_menuitem',
                             array('meid' => $meid));
    
        if ($item == false) {
            $output->Text(_MENUCONTENTNOSUCHITEM);
            return $output->GetOutput();
        }
    
        // Security check - important to do this as early as possible to avoid
        // potential security holes or just too much wasted processing.  However,
        // in this case we had to wait until we could obtain the item name to
        // complete the instance information so this is the first chance we get to
        // do the check
        if (!pnSecAuthAction(0, 'MenuExpress::Menu', ":$item[title]:$meid", ACCESS_DELETE)) {
            $output->Text(_MENUCONTENTNOAUTH);
            return $output->GetOutput();
        }
    
        // Check for confirmation. 
        if (empty($confirmation)) {
            // No confirmation yet - display a suitable form to obtain confirmation
            // of this action from the user
    
            // Create output object - this object will store all of our output so
            // that we can return it easily when required
            $output = new pnHTML();
    
            // Add menu to output - it helps if all of the module pages have a
            // standard menu at their head to aid in navigation
            $output->SetInputMode(_PNH_VERBATIMINPUT);
            $output->Text(pnModFunc('ContentExpress', 'admin', 'adminmenu'));
            $output->SetInputMode(_PNH_PARSEINPUT);
    
            // Title - putting a title ad the head of each page reminds the user
            // what they are doing
            $output->Title(_MENUCONTENTMENUDELETE);
    
            // Add confirmation to output.  Note that this uses a pnHTML helper
            // function to produce the requested confirmation in a standard
            // fashion.  This not only cuts down on code within the module but
            // allows it to be altered in future without the module developer
            // having to worry about it
            $output->ConfirmAction(_CONFIRMMENUCONTENTMENUDELETE,
                                   pnModURL('ContentExpress',
                                            'admin',
                                            'delmenu'),
                                   _CANCELMENUCONTENTMENUDELETE,
                                   pnModURL('ContentExpress',
                                            'admin',
                                            'newmenu'),
                                   array('meid' => $meid));
    
            // Return the output that has been generated by this function
            return $output->GetOutput();
        }
    
        // If we get here it means that the user has confirmed the action
        // Confirm authorisation code.  This checks that the form had a valid
        // authorisation code attached to it.  If it did not then the function will
        // proceed no further as it is possible that this is an attempt at sending
        // in false data to the system
        if (!pnSecConfirmAuthKey()) {
            pnSessionSetVar('errormsg', _BADAUTHKEY);
            pnRedirect(pnModURL('ContentExpress', 'admin', 'newmenu'));
            return true;
        }
    
        // Load API.  All of the actual work for the deletion of the item is done
        // within the API, so we need to load that in before before we can do
        // anything.  If the API fails to load an appropriate error message is
        // posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'admin')) {
            $output->Text(_LOADFAILED.":ME:admin_delete");
            return $output->GetOutput();
        }
    
        // The API function is called.  Note that the name of the API function and
        // the name of this function are identical, this helps a lot when
        // programming more complex modules.  The arguments to the function are
        // passed in as their own arguments array.
        //
        // The return value of the function is checked here, and if the function
        // suceeded then an appropriate message is posted.  Note that if the
        // function did not succeed then the API function should have already
        // posted a failure message so no action is required
        if (pnModAPIFunc('ContentExpress',
                         'admin',
                         'deletemenu',
                         array('meid' => $meid))) {
            // Success
            pnSessionSetVar('statusmsg', _MENUCONTENTMENUDELETED);

            // Check to see if the cache file for Javascript menu block exist,
            // if so, remove it and let display to recreate one to reflect new changes
            $cache = "modules/ContentExpress/pncache/jsmenu_$item[block_id].js";

            if( file_exists( $cache )) {
                unlink( $cache );
            }
        }
    
        // This function generated no output, and so now it is complete we redirect
        // the user to an appropriate page for them to carry on their work
        pnRedirect(pnModURL('ContentExpress', 'admin', 'newmenu'));
        
        // Return
        return true;
    }

    function admin_qupdate( $args )
    {
        // Get parameters from whatever input we need.  All arguments to this
        // function should be obtained from pnVarCleanFromInput(), getting them
        // from other places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        list($task, $meid, $pid, $bid) = pnVarCleanFromInput('task', 'meid', 'pid', 'bid' );
    
        // User functions of this type can be called by other modules.  If this
        // happens then the calling module will be able to pass in arguments to
        // this function through the $args parameter.  Hence we extract these
        // arguments *after* we have obtained any form-based input through
        // pnVarCleanFromInput().
        extract($args);
    
        // Confirm authorisation code.  This checks that the form had a valid
        // authorisation code attached to it.  If it did not then the function will
        // proceed no further as it is possible that this is an attempt at sending
        // in false data to the system
        if (!pnSecConfirmAuthKey()) {
            pnSessionSetVar('errormsg', _BADAUTHKEY);
            pnRedirect(pnModURL('ContentExpress', 'admin', 'editmenu',array('meid' => $meid, 'bid' => $bid) ));
            return true;
        }
    
        // Notable by its absence there is no security check here.  This is because
        // the security check is carried out within the API function and as such we
        // do not duplicate the work here
    
        // Load API.  All of the actual work for the update of the new item is done
        // within the API, so we need to load that in before we can do anything.
        // If the API fails to load an appropriate error message is posted and the
        // function returns
        if (!pnModAPILoad('ContentExpress', 'admin')) {
            pnSessionSetVar('errormsg', _LOADFAILED.":ME:admin_qupdate");
            return $output->GetOutput();
        }
    
        // The API function is called.  Note that the name of the API function and
        // the name of this function are identical, this helps a lot when
        // programming more complex modules.  The arguments to the function are
        // passed in as their own arguments array.
        //
        // The return value of the function is checked here, and if the function
        // suceeded then an appropriate message is posted.  Note that if the
        // function did not succeed then the API function should have already
        // posted a failure message so no action is required
        if(pnModAPIFunc('ContentExpress',
                        'admin',
                        'qupdmenu',
                        array('meid' => $meid,
                              'pid' => $pid,
                              'task' => $task,
                              'bid'  => $bid))) {
            // Success
            pnSessionSetVar('statusmsg', _MENUCONTENTMENUUPDATED);

            // Check to see if the cache file for Javascript menu block exist,
            // if so, remove it and let display to recreate one to reflect new changes
            $cache = "modules/ContentExpress/pncache/jsmenu_$bid.js";

            if( file_exists( $cache )) {
                unlink( $cache );
            }
        }
    
        // This function generated no output, and so now it is complete we redirect
        // the user to an appropriate page for them to carry on their work
        pnRedirect(pnModURL('ContentExpress', 'admin', 'editmenu', array('meid' => $meid, 'bid' => $bid) ));
    
        // Return
        return true;
    }

    function admin_modifyconfig()
    {
        // Create output object - this object will store all of our output so that
        // we can return it easily when required
        $output = new pnHTML();
    
        // Security check - important to do this as early as possible to avoid
        // potential security holes or just too much wasted processing
    
        if (!pnSecAuthAction(0, 'MenuExpress::Menu', '::', ACCESS_ADMIN)) {
            $output->Text(_MENUCONTENTNOAUTH);
            return $output->GetOutput();
        }
    
        // Add menu to output - it helps if all of the module pages have a standard
        // menu at their head to aid in navigation
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text(pnModFunc('ContentExpress', 'admin', 'adminmenu'));
        $output->SetInputMode(_PNH_PARSEINPUT);
    
        // Title - putting a title ad the head of each page reminds the user what
        // they are doing
        $output->Title(_MENUCONTENTMODIFYMECONFIG);
    
        // Start form - note the use of pnModURL() to create the recipient URL of
        // this form.  All URLs should be generated through pnModURL() to ensure
        // compatibility with future versions of PostNuke
        $output->FormStart(pnModURL('ContentExpress', 'admin', 'updatemeconfig'));
    
    
        // Add an authorisation ID - this adds a hidden field in the form that
        // contains an authorisation ID.  The authorisation ID is very important in
        // preventing certain attacks on the website
        $output->FormHidden('authid', pnSecGenAuthKey());
    
        // Start the table that holds the information to be modified.  Note how
        // each item in the form is kept logically separate in the code; this helps
        // to see which part of the code is responsible for the display of each
        // item, and helps with future modifications
        $output->TableStart( "", "", 0, "100%", 0, 0 );
    
        $enable_qadmin = pnModGetVar('MenuExpress', 'enable_qadmin');
        $pnmenu_style = pnModGetVar('MenuExpress', 'pnmenu_style');
     
        // Enable/Disable quick admin link
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(pnVarPrepForDisplay(_MENUCONTENTQADMIN));
        $row[] = $output->FormCheckbox('enable_qadmin', $enable_qadmin );
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Enable/Disable PN menu style
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(pnVarPrepForDisplay(_MENUCONTENTPNMENU));
        $row[] = $output->FormCheckbox('pnmenu_style', $pnmenu_style );
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);
    
        // End form
        $output->TableEnd();
        $output->Linebreak(2);
        $output->FormSubmit(_MENUCONTENTUPDATECONFIG);
        $output->FormEnd();
        
        // Return the output that has been generated by this function
        return $output->GetOutput();
    }

    function admin_updateconfig( $args )
    {
        // Get parameters from whatever input we need.  All arguments to this
        // function should be obtained from pnVarCleanFromInput(), getting them
        // from other places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        $enable_qadmin = pnVarCleanFromInput( 'enable_qadmin' );
        $pnmenu_style = pnVarCleanFromInput( 'pnmenu_style' );
    
        extract( $args );
    
        // Confirm authorisation code.  This checks that the form had a valid
        // authorisation code attached to it.  If it did not then the function will
        // proceed no further as it is possible that this is an attempt at sending
        // in false data to the system
        if (!pnSecConfirmAuthKey()) {
            pnSessionSetVar('errormsg', _BADAUTHKEY);
            pnRedirect(pnModURL('ContentExpress', 'admin', 'view'));
            return true;
        }
    
        // Update module variables.  Note that depending on the HTML structure used
        // to obtain the information from the user it is possible that the values
        // might be unset, so it is important to check them all and assign them
        // default values if required
        pnModSetVar('MenuExpress', 'enable_qadmin', $enable_qadmin);
        pnModSetVar('MenuExpress', 'pnmenu_style', $pnmenu_style);
    
        pnSessionSetVar('statusmsg', _MENUCONTENTCONFIGUPDATED);

        // This function generated no output, and so now it is complete we redirect
        // the user to an appropriate page for them to carry on their work
        pnRedirect(pnModURL('ContentExpress', 'admin', 'view'));
    
        // Return
        return true;
    }

    // function to build menu form
    function admin_build_form( $title, $btn_label, $item = 0, $bitem = 0, $args = array())
    {
        $output = new pnCEHTML();
        extract($args);
        $currlang = pnUserGetLang();
        // Title - putting a title ad the head of each page reminds the user what
        // they are doing
        $output->Title($title);
        $output->UploadMode();
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text( '<script type="text/javascript" src="modules/ContentExpress/js/menu_validate.js"></script>' );
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Start form - note the use of pnModURL() to create the recipient URL of
        // this form.  All URLs should be generated through pnModURL() to ensure
        // compatibility with future versions of PostNuke
        if( $item != 0 && !empty( $item )) {
            $output->CEFormStart(pnModURL('ContentExpress', 'admin', 'updatemenu'), 'editmenu' );
    
            // Add a hidden variable for the item id.  This needs to be passed on to
            // the update function so that it knows which item for which item to carry
            // out the update
            $output->FormHidden('meid', pnVarPrepForDisplay($item['id']));
        } else {
            $output->CEFormStart(pnModURL('ContentExpress', 'admin', 'createmenu'), 'newmenu' );
        }
    
        // Add an authorisation ID - this adds a hidden field in the form that
        // contains an authorisation ID.  The authorisation ID is very important in
        // preventing certain attacks on the website
        $output->FormHidden('authid', pnSecGenAuthKey());
    
        foreach( $args as $name => $value ) {
            $output->FormHidden( $name, $value );
        }

        // Start the table that holds the information to be input.  Note how each
        // item in the form is kept logically separate in the code; this helps to
        // see which part of the code is responsible for the display of each item,
        // and helps with future modifications
        $output->TableStart();
    
        $menus = array();
        $comparator = create_function( '$item', 'if(( $item[menutype] > 2 ) && ( $item[status] == 2 )) { return true; } else { return false; }' );
        if( $item != 0 && !empty( $item )) {
            CommonExpress_build_item_list($menus, "menuitems", $item['id'], $comparator );
        } else {
            CommonExpress_build_item_list($menus, "menuitems", $comparator );
        }
    
        // TODO: This eventually becomes a module list along with each module has its own item lists
        $contents = array();
        CommonExpress_build_item_list($contents, "contentitems",-1,NULL,'admin');
    
        $statuses = array();
        CommonExpress_build_item_list($statuses, "statusitems" );

        $blocks = CommonExpress_getallblocks( pnModGetIDFromName('ContentExpress'), array( "jsmenu", "menu" ), $currlang );

        // language list
        $langlist = languagelist();
        $lang = array();
        $lang[] = array( 'id' => 'x_all', 'selected' => 0, 'name' => 'All' );
        foreach( $langlist as $l => $lan ) {
            if( $l == $currlang ) {
                $lang[] = array( 'id' => $l, 'selected' => 1, 'name' => $lan );
            }
            else {
                $lang[] = array( 'id' => $l, 'selected' => 0, 'name' => $lan );
            }
        }
    
        // Name
        $output->TableRowStart();
        $output->TableColStart( 1, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTMENUNAME));
        $output->TableColEnd();
        $output->TableColStart( 3, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormText('title', $item['title'], 32, 32);
        } else {
            $output->FormText('title', '', 32, 32);
        }
        $output->TableColEnd();
        $output->TableRowEnd();
    
        // Type
        $output->TableRowStart();
        $output->TableColStart( 4, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTMENUTYPE));
        $output->TableColEnd();
        $output->TableRowEnd();
        $output->TableRowStart();
        $output->TableColStart( 4, 'left' );
        if( $item != 0 && !empty( $item )) {  // Spacer, type 1
            $output->FormCheckbox( 'menutype', ($item['menutype'] == 1) ? true : false, '1', 'radio' );
        } else {
            $output->FormCheckbox( 'menutype', false, '1', 'radio' );
        }
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTMENUTYPE1));
        $output->TableColEnd();
        $output->TableRowEnd();
        $output->TableRowStart();
        $output->TableColStart( 4, 'left' );
        if( $item != 0 && !empty( $item )) { // Title, type 2
            $output->FormCheckbox( 'menutype', ($item['menutype'] == 2) ? true : false, '2', 'radio' );
        } else {
            $output->FormCheckbox( 'menutype', false, '2', 'radio' );
        }
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTMENUTYPE2));
        $output->TableColEnd();
        $output->TableRowEnd();

        // Clickable Title menu item
        $output->TableRowStart();
        $output->TableColStart( 4, 'left' );
        if( $item != 0 && !empty( $item )) { // Clickable title, type 5
            $output->FormCheckbox( 'menutype', ($item['menutype'] == 5) ? true : false, '5', 'radio' );
        } else {
            $output->FormCheckbox( 'menutype', true, '5', 'radio' );
        }
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTMENUTYPE5));
        $output->TableColEnd();
        $output->TableRowEnd();

        $content_list = array();
        foreach( $contents as $id => $content_title ) {
            $content_list[] = array( 'id' => pnModURL('ContentExpress', 'user', 'display', array( 'ceid' => $id )), 'selected' => ($item['uri']==pnModURL('ContentExpress', 'user', 'display', array( 'ceid' => $id )))?1:0, 'name' => "[ContentExpress]$content_title" );
        }
    
        // Menu URI
        $output->TableRowStart();
        $output->TableColStart( 4, 'left' );
        if( $item != 0 && !empty( $item )) { // Module, type 3
            $output->FormCheckbox( 'menutype', ($item['menutype'] == 3) ? true : false, '3', 'radio' );
        } else {
            $output->FormCheckbox( 'menutype', false, '3', 'radio' );
        }
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTMENUTYPE3));
        $output->Text(" ");
        if( $item != 0 && !empty( $item )) {
            $output->FormSelectMultiple('moduri', $content_list, 0, 1, $item['uri'] );
        } else {
            $output->FormSelectMultiple('moduri', $content_list );
        }
        $output->TableRowEnd();
        $output->TableRowStart();
        $output->TableColStart( 4, 'left' );
        if( $item != 0 && !empty( $item )) { // Custom URL, type 4
            $output->FormCheckbox( 'menutype', ($item['menutype'] == 4) ? true : false, '4', 'radio' );
        } else {
            $output->FormCheckbox( 'menutype', true, '4', 'radio' );
        }
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTMENUTYPE4));
        $output->Text(" ");
        $output->FormText('uri', $item['uri'], 96, 256);
        $output->TableColEnd();
        $output->TableRowEnd();
    
        // parent list should be retreived from database
        // non-clickable title menu item and spacer should not be included in the parent list
        $parents = array();
        $parents[] = array( 'id' => -1, 'selected' => 0, 'name' => _MENUCONTENTTOPLEVEL );
        foreach( $menus as $id => $menu ) {
            // Thanks to Iassen Manov for the bug fixes (bug# 706333)
            if( !empty( $item )) {
                $parents[] = array( 'id' => $id, 'selected' => ($item['parent_id']==$id)?1:0, 'name' => $menu );
            } else {
                $parents[] = array( 'id' => $id, 'selected' => 0, 'name' => $menu );
            }
        }
    
        // Parent Menu
        $output->TableRowStart();
        $output->TableColStart( 1, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTMENUPARENT));
        $output->TableColEnd();
        $output->TableColStart( 3, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormSelectMultiple('parent_id', $parents, 0, 1, $item['parent_id'] );
        } else {
            $output->FormSelectMultiple('parent_id', $parents );
        }
        $output->TableColEnd();
        $output->TableRowEnd();
    
        $output->TableRowStart();
        // Status
        $output->TableColStart( 1, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTMENUSTATE));
        $output->TableColEnd();

        $status = array();
        foreach( $statuses as $s => $state ) {
            if( $s == $item['status'] ) {
                $status[] = array( 'id' => $s, 'selected' => 1, 'name' => $state );
            } else {
                $status[] = array( 'id' => $s, 'selected' => 0, 'name' => $state );
            }
        }

        $output->TableColStart( 1, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormSelectMultiple('status', $status, 0, 1, $item['status'] );
        } else {
            $output->FormSelectMultiple('status', $status );
        }
        $output->TableColEnd();
        // Weight
        $output->TableColStart( 1, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTMENUWEIGHT));
        $output->TableColEnd();
        $output->TableColStart( 1, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormText('weight', $item['weight']);
        } else {
            $output->FormText('weight', 10 );
        }
        $output->TableColEnd();
        $output->TableRowEnd();

        $output->TableRowStart();
        // Open menu item within new window?
        $output->TableColStart( 1, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTMENUNEWWINDOW));
        $output->TableColEnd();
        $output->TableColStart( 1, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormCheckbox('newwindow', $item['newwindow'] ? true : false );
        } else {
            $output->FormCheckbox('newwindow', false );
        }
        $output->TableColEnd();
        $output->TableColStart( 2, 'left' );
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text("<b>".pnVarPrepForDisplay(_MENUCONTENTSCHEDULEMENU)."</b>");
        $output->SetInputMode(_PNH_PARSEINPUT);
        $output->TableColEnd();
        $output->TableRowEnd();

        // popup calendar javascript
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text( '<script type="text/javascript" src="modules/ContentExpress/js/ts_picker.js">'.
                       '//Script by Denis Gritcyuk: tspicker@yahoo.com'.
                       '//Submitted to JavaScript Kit (http://javascriptkit.com)'.
                       '//Visit http://javascriptkit.com for this script' );  
        $output->Text( '</script>' );
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Block it belongs to
        // parent list should be retreived from database
        $blks = array();
        $blks[] = array( 'id' => -1, 'selected' => 0, 'name' => _MENUCONTENTALLBLOCKS );
        if ( is_array($blocks) && count($blocks) > 0 ) {
     	    foreach( $blocks as $blk ) {
                $blks[] = array( 'id' => $blk['bid'], 'selected' => ($blk['bid']==$item['block_id'])?1:0, 'name' => $blk['title'] );
            }
        }
    
        $output->TableRowStart();
        $output->TableColStart( 1, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTBLOCK));
        $output->TableColEnd();
        $output->TableColStart( 1, 'left' );
        if( $bitem != 0 && !empty( $bitem )) {
            $output->FormSelectMultiple('bid', $blks, 0, 1, $bitem['bid'] );
        } else {
            $output->FormSelectMultiple('bid', $blks );
        }
        $output->TableColEnd();

        // Start Date
        $output->TableColStart( 1, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTSTARTDATE));
        $output->TableColEnd();
        $output->TableColStart( 1, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormText('start_date', $item['start_date']);
        } else {
            $output->FormText('start_date');
        }
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        if( $item != 0 && !empty( $item )) {
            $output->Text( "<a href=\"javascript:show_calendar('document.editmenu.start_date', document.editmenu.start_date.value);\"><img src=\"modules/ContentExpress/pnimages/cal.gif\" width=\"16\" height=\"16\" border=\"0\" alt=\"Click here to pick the date/time\"></a>");
        } else {
            $output->Text( "<a href=\"javascript:show_calendar('document.newmenu.start_date', document.newmenu.start_date.value);\"><img src=\"modules/ContentExpress/pnimages/cal.gif\" width=\"16\" height=\"16\" border=\"0\" alt=\"Click here to pick the date/time\"></a>");
        }
        $output->SetInputMode(_PNH_PARSEINPUT);
        $output->TableColEnd();
        $output->TableRowEnd();
    
        $output->TableRowStart();
        // Language
        $output->TableColStart( 1, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTMENULANG));
        $output->TableColEnd();
        $output->TableColStart( 1, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormSelectMultiple('language', $lang, 0, 1, $item['language'] );
        } else {
            $output->FormSelectMultiple('language', $lang );
        }
        $output->TableColEnd();
    
        // End Date
        $output->TableColStart( 1, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTENDDATE));
        $output->TableColEnd();
        $output->TableColStart( 1, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormText('end_date', $item['end_date']);
        } else {
            $output->FormText('end_date');
        }
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        if( $item != 0 && !empty( $item )) {
            $output->Text( "<a href=\"javascript:show_calendar('document.editmenu.end_date', document.editmenu.end_date.value);\"><img src=\"modules/ContentExpress/pnimages/cal.gif\" width=\"16\" height=\"16\" border=\"0\" alt=\"Click here to pick the date/time\"></a>");
        } else {
            $output->Text( "<a href=\"javascript:show_calendar('document.newmenu.end_date', document.newmenu.end_date.value);\"><img src=\"modules/ContentExpress/pnimages/cal.gif\" width=\"16\" height=\"16\" border=\"0\" alt=\"Click here to pick the date/time\"></a>");
        }
        $output->SetInputMode(_PNH_PARSEINPUT);
        $output->TableColEnd();
        $output->TableRowEnd();
    
        // Menu item images
        $output->TableRowStart();
        $output->TableColStart( 4, 'left' );
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text("<b>".pnVarPrepForDisplay(_MENUCONTENTMENUIMAGES)."</b>");
        $output->SetInputMode(_PNH_PARSEINPUT);
        $output->TableColEnd();
        $output->TableRowEnd();
        $max_img_size = pnModGetVar( 'MenuExpress', 'max_img_size' );

        $output->TableRowStart();
        $output->TableColStart( 1, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTMENUROLLIMGA));
        $output->TableColEnd();
        $output->TableColStart( 3, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormText('rollover_img1_file', $item['rollover_img1_file'], 32);
            $output->Text( " " ); 
            $output->FormFile('rollover_img1', 10, $max_img_size);
        } else {
            $output->FormText('rollover_img1_file', '', 32 );
            $output->Text( " " );
            $output->FormFile('rollover_img1', 10, $max_img_size);
        }
        $output->FormCheckbox('rollover_img1_del', false );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTDELETE));
        $output->TableColEnd();
        $output->TableRowEnd();

        $output->TableRowStart();
        $output->TableColStart( 1, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTMENUROLLIMGB));
        $output->TableColEnd();
        $output->TableColStart( 3, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormText('rollover_img2_file', $item['rollover_img2_file'], 32);
            $output->Text( " " ); 
            $output->FormFile('rollover_img2', 10, $max_img_size);
        } else {
            $output->FormText('rollover_img2_file', '', 32);
            $output->Text( " " );
            $output->FormFile('rollover_img2', 10, $max_img_size);
        }
        $output->FormCheckbox('rollover_img2_del', false );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTDELETE));
        $output->TableColEnd();
        $output->TableRowEnd();

        $output->TableRowStart();
        $output->TableColStart( 1, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTMENUBGIMG));
        $output->TableColEnd();
        $output->TableColStart( 3, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormText('bg_img_file', $item['bg_img_file'], 32);
            $output->Text( " " ); 
            $output->FormFile('bg_img', 10, $max_img_size);
        } else {
            $output->FormText('bg_img_file', '', 32);
            $output->Text( " " );
            $output->FormFile('bg_img', 10, $max_img_size);
        }
        $output->FormCheckbox('bg_img_del', false );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTDELETE));
        $output->TableColEnd();
        $output->TableRowEnd();

        $output->TableEnd();
    
        // End form
        $output->Linebreak(2);
        $output->FormSubmit($btn_label);
        $output->FormEnd();
    
        return $output->GetOutput();
    }

    /**
     * generate menu fragment
     */
    function user_menu($args)
    {
        // Get parameters from whatever input we need.  All arguments to this
        // function should be obtained from pnVarCleanFromInput(), getting them
        // from other places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke.
        list($ceid, $meid) = pnVarCleanFromInput('ceid', 'meid');
    
        // Create output object - this object will store all of our output so that
        // we can return it easily when required
        $output = new pnHTML();
    
        // Display status message if any.  Note that in future this functionality
        // will probably be in the theme rather than in this menu, but this is the
        // best place to keep it for now
    
        // Start options menu
        $status = trim( pnGetStatusMsg());
        if( strlen( $status ) > 0 ) {
       	    $output->Text($status);
            $output->Linebreak();
        }
    
        // Load API.  All of the actual work for obtaining information on the items
        // is done within the API, so we need to load that in before we can do
        // anything.  If the API fails to load an appropriate error message is
        // posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'user')) {
            $output->Text(_LOADFAILED.":ME:user_menu");
            return $output->GetOutput();
        }
    
        if( $ceid > 0 ) {

            // Fix contributed by JanPhilipp, comment the following linebreak will 
            // get rid of the annoying link break at the top of the line
            // $output->Linebreak(1);

            // The API function is called.  The arguments to the function are passed in
            // as their own arguments array
            $item = pnModAPIFunc('ContentExpress',
                                 'user',
                                 'get_contentitem',
                                 array('ceid' => $ceid));
    
            // The return value of the function is checked here, and if the function
            // suceeded then an appropriate message is posted.  Note that if the
            // function did not succeed then the API function should have already
            // posted a failure message so no action is required
            if ($item == false) {
                $output->Text(_MENUCONTENTITEMFAILED);
                return $output->GetOutput();
            }
        }
    
        // Return the output that has been generated by this function
        return $output->GetOutput();
    }

    //--------------------------------------------------------------------------------------
    //
    // Static/Dynamic menu item block section
    //
    //--------------------------------------------------------------------------------------

    // Menu block related methods
    function menublock_init()
    {
        // Security
        pnSecAddSchema('MenuExpress::Menu', 'Block ID:Link name:Link ID');
        pnSecAddSchema('MenuExpress::Menublock', 'Block title::Block ID');
    }

    function menublock_info()
    {
        // Values
        return array('text_type' => 'Menu',
                     'module' => 'ContentExpress',
                     'text_type_long' => 'CE Menu Block',
                     'allow_multiple' => true,
                     'form_content' => false,
                     'form_refresh' => true,
                     'show_preview' => true);
    }

    function menublock_modify( $blockinfo )
    {
        // Create output object
        $output = new pnHTML();

        // Get current content
        $vars = pnBlockVarsFromContent($blockinfo['content']);
    
        // Create row
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_MUDYNAMICMENU);
        $row[] = $output->FormCheckbox('dynmenu', $vars['dynmenu']);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
    
        // Add row
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->TableAddRow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);

 
        // Return output
        return $output->GetOutput();
    }

    function menublock_update( $blockinfo )
    {
        $dyn = pnVarCleanFromInput('dynmenu');

        $vars['dynmenu'] = empty( $dyn ) ? 0 : 1;

        $blockinfo['content'] = pnBlockVarsToContent($vars);

        return $blockinfo;
    }

    function menublock_display( $blockinfo )
    {
        // Security check
        if (!pnSecAuthAction(0, "MenuExpress::Menublock", "$blockinfo[title]::$blockinfo[bid]", ACCESS_READ)) {
            return;
        }
        // Get variables from content block
        $vars = pnBlockVarsFromContent($blockinfo['content']);
    
        list($ceid, $meid) = pnVarCleanFromInput('ceid', 'meid');
    
        if( !isset( $ceid )) {
            $ceid = -1;
        }
    
        if( !isset( $meid )) {
            $meid = -1;
        }
    
        // Database information
        pnModDBInfoLoad('ContentExpress');
    
        // Create output object
        $output = new pnCEHTML();
    
        // Load API.  Note that this is loading the user API, that is because the
        // user API contains the function to obtain item information which is the
        // first thing that we need to do.  If the API fails to load an appropriate
        // error message is posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'user')) {
            $output->Text(_LOADFAILED.":ME:menublock_display");
            return $output->GetOutput();
        }
    
        // The user API function is called.  This takes the item ID which we
        // obtained from the input and gets us the information on the appropriate
        // item.  If the item does not exist we post an appropriate message and
        // return
        $items = pnModAPIFunc('ContentExpress',
                              'user',
                              'getall_menuitems',
                              array( 'bid' => $blockinfo['bid'],
                                     'btitle' => $blockinfo['title'],
                                     'curr_date' => strftime( "%Y-%m-%d %H:%M:%S", time()),
                                     'curr_status' => 2 ));
    
        $enable_qadmin = pnModGetVar('MenuExpress', 'enable_qadmin');
        $mytheme = pnUserGetTheme();
    
        if( pnSecAuthAction( 0, "MenuExpress::", "::", ACCESS_ADMIN ) && $enable_qadmin ) {
            $edit = CommonExpress_display_themeable_anchor( $mytheme, 
                                                       pnModURL( 'ContentExpress', 'admin', 'newmenu', 
						                 array( 'bid' => $blockinfo['bid'],
								        'btitle' => pnVarPrepForDisplay( $blockinfo['title'] ))),
                                                       _MENUCONTENTEDITMENU,
                                                       "edit" );
                                                       
            $row = array();
            $row[] = $edit;
            $output->TableStart();
            $output->SetInputMode(_PNH_VERBATIMINPUT);
            $output->TableAddRow( $row, 'right' );
            $output->SetInputMode(_PNH_PARSEINPUT);
            $output->TableEnd();
        }
    
        if ($items != false) {
    
            $output->SetOutputMode(_PNH_RETURNOUTPUT);
    
            // Get the menu info
            $curr_meid = $meid;
            $menus = array();
            foreach( $items as $item ) {
                if( $item['status'] > 0 ) {
    
                    if( $item['menutype'] == 1 ) {
                        $menu = $output->Text( "" );
                    }
                    else if( $item['menutype'] == 2 ) {
                        $menu = $output->Text( $item['title'] );
                    }
                    else if( $item['menutype'] == 3 ) {
                        // TODO: pnHTML::URL does not support _target option,
                        //       either modify the pnHTML::URL
                        //       or override it in pnCEHTML,
                        //       we pick the latter approach
                        $menu = $output->URL(
                            $item['uri']."&bid=$blockinfo[bid]&btitle=".pnVarPrepForDisplay( $blockinfo['title'] )."&meid=$item[id]",
                            $item['title'],
                            false,
                            $item['newwindow'] );
                    }
                    // figure out what is the previous URL and replace meid if argument exists or
                    // append meid if no such argument.
                    else if( $item['menutype'] == 5 ) {
                        $uri = "?meid=$item[id]$item[uri]";
                        $menu = $output->URL( $uri, $item['title'],
                                              false, $item['newwindow'] );
                    }
                    else {
                        $uri = $item['uri'];
                        if( preg_match( "/^http:\/\/.+/", $item['uri'], $matches ) > 0 ) {
                            // Parse to see if this is external web link, if so, don't mess with it
                            // Do nothing
                        } else if( preg_match( "/\[(.+)\](.*)/i", $item['uri'], $matches ) > 0 ) {
                            // Parse to see if there is any [<module>] syntax, if so, need to regenerate
                            // the URI for browser
                            $uri = "modules.php?op=modload&name=$matches[1]&file=index$matches[2]&meid=$item[id]";
                        } else if( preg_match( "/.+\?.+/", $item['uri'] ) > 0 ) {
                            // this is internal web link, parse to see if there is any argument attached
                            // already. if so, append meid to the end so the menu item "arrow" will
                            // display properly
                            $uri .= "&meid=$item[id]";
                        } else {
                            // otherwise append ? and the arguement only 
                            $uri .= "?meid=$item[id]";
                        }
                        // TODO: pnHTML::URL does not support _target option,
                        //       either modify the pnHTML::URL
                        //       or override it in pnCEHTML,
                        //       we pick the latter approach
                        if( $item['rollover_img1_file'] != "" && $item['rollover_img2_file'] != "" ) {
                            $menu = "<a name=\"$item[title]\" href=\"$uri\" ";
                            if( $item['newwindow'] ) {
                                $menu .= "_target=\"blank\"";
                            }
                            $menu .= "onMouseOver=\"document.me$item[id].src='$item[rollover_img1_file]'\" ".
                                     "onMouseOut=\"document.me$item[id].src='$item[rollover_img2_file]'\">".
                                     "<img name=\"me$item[id]\" border=\"0\" alt=\"$item[title]\" src=\"$item[rollover_img2_file]\"></a>";
                        } else {
                            $menu = $output->URL( $uri, $item['title'],
                                                  false, $item['newwindow'] );
                        }
                    }
    
                    if( $item['id'] == $meid || ( $item['menutype'] == 3 && $ceid > 0 )) {
                        $curr_meid = $meid;
                    }
    
                    $menus[($item['id']+0)] = array( 'id'        => ($item['id']+0),
                                                     'name'      => $item['title'],
                                                     'title'     => $menu,
                                                     'menutype'  => $item['menutype'],
                                                     'newwindow' => $item['newwindow'],
                                                     'parent'    => ($item['parent_id']+0),
                                                     'weight'    => ($item['weight']+0),
                                                     'child'     => array() );
                }
            }
    
            // Locate child menu items for each menu item
            foreach( $menus as $id => $menuitem ) {
                $parent_id = $menuitem['parent'];
                if( $parent_id > 0 && !empty($menus[$parent_id])) {
                    // locates the parent and then updates its child list
                    array_push( $menus[$parent_id]['child'], $id );
                }
            }
    
            // Expand all sibling menu items along the menu path
            $menus2 = array();

            if( !empty( $vars['dynmenu'] ) && $vars['dynmenu'] > 0 ) {
                CommonExpress_build_dynitems_tree( $menus, $menus2, $curr_meid );
            } else {
                $menus2 = $menus;
            }
    
            $output->SetOutputMode(_PNH_KEEPOUTPUT);
    
            // build the tree
            foreach( $menus2 as $id => $menuitem ) {
                if( $menuitem['parent'] == -1 ) {
                    $this->build_menublock_tree( $output, $blockinfo, $menus2, $menuitem, $curr_meid );
                }
            }
        }
    
        // Populate block info and pass to theme
        $blockinfo['content'] = "<font class=\"pn-menu-title\">".$output->GetOutput()."</font>";
        return themesideblock($blockinfo);
    }

    //-------------------------------------------------------------------------------------------------
    //
    // Javascript menu block section
    //
    //-------------------------------------------------------------------------------------------------
    // It generates the modules/ContentExpress/pncache/jsmenu_<bid>_<gid>.js and it requires theme to
    // include this auto-generated java script to before including modules/ContentExpress/pnblocks/menu_com.js
    // This actually get quite complicated due to the fact that the Javascript menu need to accommodate
    // the permission of what menu item is hidden from the particular user and what is not. And we don't
    // want to have that dynamically generated all the time to speed performance.  In addition, we need
    // to deal with expiration of each menu item, if applicable.

    function menublock_jsinit()
    {
        pnSecAddSchema('MenuExpress::Menu', 'Block ID:Link name:Link ID');
        pnSecAddSchema('MenuExpress::Menublock', 'Block title::Block ID');
    }

    function menublock_jsinfo()
    {
        return array('text_type' => 'JSMenu',
                     'module' => 'ContentExpress',
                     'text_type_long' => 'CE JS Menu Block',
                     'allow_multiple' => false,
                     'form_content' => false,
                     'form_refresh' => false,
                     'show_preview' => true);
    }

    function menublock_jsmodify( $blockinfo )
    {
        // Create output object
        $output = new pnHTML();

        // To use color picker, changes are needed for the core files:
        // 1) pnHTML::FormStart() need to add optional parameter, $name = ""
        // 2) pnadmin.php of Blocks need to specify "blockform" for the $name
        //    of FormStart() method call
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text( "<script type=\"text/javascript\" src=\"modules/ContentExpress/js/picker.js\"></script>" );
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Get current parameter settings
        $jsm_settings = pnBlockVarsFromContent($blockinfo['content']);
    
        // Color settings and others for javascript menu manipulated here.
        $rows = array();

        // Licensing warning
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $row[] = $output->Text("<b>"._JSMBLICENSE."</b>");
        $output->SetInputMode(_PNH_PARSEINPUT);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // Javascript menublock height
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBHEIGHT);
        $row[] = $output->FormText('jmbheight', pnModGetVar('MenuExpress', 'jmbheight'));
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;
    
        // Javascript menublock width
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBWIDTH);
        $row[] = $output->FormText('jmbwidth', pnModGetVar('MenuExpress', 'jmbwidth'));
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;
    
        // Low background color
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBLOWBGCOLOR);
        $row[] = $output->FormText('lowbgcolor', isset($jsm_settings['lowbgcolor'])?$jsm_settings['lowbgcolor']:"#DEE4EB").
                 "<script type=\"text/javascript\">
                      ShowTCPButton( 'blockform', 'lowbgcolor' );
                  </script>";
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;
    
        // High background color
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBHIGHBGCOLOR);
        $row[] = $output->FormText('hibgcolor', isset($jsm_settings['hibgcolor'])?$jsm_settings['hibgcolor']:"#9CA2B6").
                 "<script type=\"text/javascript\">
                      ShowTCPButton( 'blockform', 'hibgcolor' );
                  </script>";
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;
    
        // Font low color
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBFONTLOWCOLOR);
        $row[] = $output->FormText('fontlowcolor', isset($jsm_settings['fontlowcolor'])?$jsm_settings['fontlowcolor']:"#000000").
                 "<script type=\"text/javascript\">
                      ShowTCPButton( 'blockform', 'fontlowcolor' );
                  </script>";
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;
    
        // Font high color
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBFONTHIGHCOLOR);
        $row[] = $output->FormText('fonthicolor', isset($jsm_settings['fonthicolor'])?$jsm_settings['fonthicolor']:"#FFFFFF").
                 "<script type=\"text/javascript\">
                      ShowTCPButton( 'blockform', 'fonthicolor' );
                  </script>";
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;
    
        // Border color
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBBORDERCOLOR);
        $row[] = $output->FormText('bordercolor', isset($jsm_settings['bordercolor'])?$jsm_settings['bordercolor']:"#000000").
                 "<script type=\"text/javascript\">
                      ShowTCPButton( 'blockform', 'bordercolor' );
                  </script>";
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;
    
        // Main menu item border width
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBMAINBORDERWIDTH);
        $row[] = $output->FormText('borderwidthmain', isset($jsm_settings['borderwidthmain'])?$jsm_settings['borderwidthmain']:0);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;
    
        // Sub-menu item border width
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBSUBBORDERWIDTH);
        $row[] = $output->FormText('borderwidthsub', isset($jsm_settings['borderwidthsub'])?$jsm_settings['borderwidthsub']:0);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;
    
        // Border between main menu item
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBBORDERBTWMAIN);
        $row[] = $output->FormCheckbox('borderbtwmain', $jsm_settings['borderbtwmain']);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;
    
        // Border between sub-menu item
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBBORDERBTWSUB);
        $row[] = $output->FormCheckbox('borderbtwsub', $jsm_settings['borderbtwsub']);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;
    
        // Menu item max. height
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBMUMAXHEIGHT);
        $row[] = $output->FormText('menumaxheight', isset($jsm_settings['menumaxheight'])?$jsm_settings['menumaxheight']:12);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // Menu item max. width
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBMUMAXWIDTH);
        $row[] = $output->FormText('menumaxwidth', isset($jsm_settings['menumaxwidth'])?$jsm_settings['menumaxwidth']:100);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // Font family
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBFONTFAMILY);
        $row[] = $output->FormText('fontfamily', isset($jsm_settings['fontfamily'])?$jsm_settings['fontfamily']:"Tahoma");
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // Font size
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBFONTSIZE);
        $row[] = $output->FormText('fontsize', isset($jsm_settings['fontsize'])?$jsm_settings['fontsize']:8);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // Font bold
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBFONTBOLD);
        $row[] = $output->FormCheckbox('fontbold', $jsm_settings['fontbold']);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // Font italic
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBFONTITALIC);
        $row[] = $output->FormCheckbox('fontitalic', $jsm_settings['fontitalic']);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // Menu text alignment
        $mtc_list = array();
        $mtc_list[] = array( 'id' => 'left', 'selected' => '0', 'name' => _JSMBMTALEFT );
        $mtc_list[] = array( 'id' => 'center', 'selected' => '0', 'name' => _JSMBMTACENTER );
        $mtc_list[] = array( 'id' => 'right', 'selected' => '0', 'name' => _JSMBMTARIGHT );
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBMENUTEXTCENTERED);
        $row[] = $output->FormSelectMultiple('menutextcentered', $mtc_list, 0, 1, $jsm_settings['menutextcentered']);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // Menu horizontal alignment 
        $mtc_list[] = array( 'id' => 'justify', 'selected' => '0', 'name' => _JSMBMTAJUSTIFY );
        $mtc_list[] = array( 'id' => 'leftjustify', 'selected' => '0', 'name' => _JSMBMTALEFTJUSTIFY );
        $mtc_list[] = array( 'id' => 'centerjustify', 'selected' => '0', 'name' => _JSMBMTACENTERJUSTIFY );
        $mtc_list[] = array( 'id' => 'rightjustify', 'selected' => '0', 'name' => _JSMBMTARIGHTJUSTIFY );
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBMENUCENTERED);
        $row[] = $output->FormSelectMultiple('menucentered', $mtc_list, 0, 1, $jsm_settings['menucentered']);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // Menu vertical alignment 
        $mva_list = array();
        $mva_list[] = array( 'id' => 'top', 'selected' => '0', 'name' => _JSMBMTATOP );
        $mva_list[] = array( 'id' => 'middle', 'selected' => '0', 'name' => _JSMBMTAMIDDLE );
        $mva_list[] = array( 'id' => 'bottom', 'selected' => '0', 'name' => _JSMBMTABOTTOM );
        $mva_list[] = array( 'id' => 'static', 'selected' => '0', 'name' => _JSMBMTASTATIC );
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBMENUVERTCENTERED);
        $row[] = $output->FormSelectMultiple('menuvertcentered', $mva_list, 0, 1, $jsm_settings['menuvertcentered']);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;
        // Target Location ID
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBTARGETLOCID);
        $row[] = $output->FormText('targetlocid', isset($jsm_settings['targetlocid'])?$jsm_settings['targetlocid']:"");
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // Start top
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBSTARTTOP);
        $row[] = $output->FormText('starttop', isset($jsm_settings['starttop'])?$jsm_settings['starttop']:0);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // Start left
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBSTARTLEFT);
        $row[] = $output->FormText('startleft', isset($jsm_settings['startleft'])?$jsm_settings['startleft']:0);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // Vertical Correct
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBVERTCORRECT);
        $row[] = $output->FormText('vercorrect', isset($jsm_settings['vercorrect'])?$jsm_settings['vercorrect']:0);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // Horizontal Correct
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBHORCORRECT);
        $row[] = $output->FormText('horcorrect', isset($jsm_settings['horcorrect'])?$jsm_settings['horcorrect']:0);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // Top Padding
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBTOPPADDING);
        $row[] = $output->FormText('toppadding', isset($jsm_settings['toppadding'])?$jsm_settings['toppadding']:0);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // Left Padding
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBLEFTPADDING);
        $row[] = $output->FormText('leftpadding', isset($jsm_settings['leftpadding'])?$jsm_settings['leftpadding']:6);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // Unfold Delay
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBUNFOLDDELAY);
        $row[] = $output->FormText('unfolddelay', isset($jsm_settings['unfolddelay'])?$jsm_settings['unfolddelay']:100);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // Menu Orientation
        $mo_list = array();
        $mo_list[] = array( 'id' => 1, 'selected' => '0', 'name' => _JSMBMTAHORIZONTAL );
        $mo_list[] = array( 'id' => 0, 'selected' => '0', 'name' => _JSMBMTAVERTICAL );
		//if(($jsm_settings['menuorient'])) {
			if($jsm_settings['menuorient'] == 1)
				$mo_list[0][selected] = '1';
			else
				$mo_list[1][selected] = '1';
		//}
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBMENUORIENTATION);
        $row[] = $output->FormSelectMultiple('menuorient', $mo_list, 0, 1, $jsm_settings['menuorient']);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // Disappearing Delay
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBDISAPPEARDELAY);
        $row[] = $output->FormText('disappeardelay', isset($jsm_settings['disappeardelay'])?$jsm_settings['disappeardelay']:1000);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // Base hyper reference
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBBASEHREF);
        $row[] = $output->FormText('basehref', $jsm_settings['basehref']);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // Unfold on click
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBUNFOLDONCLICK);
        $row[] = $output->FormCheckbox('unfoldonclick', $jsm_settings['unfoldonclick']);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // MS IE 6 Slide
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBMSIE6SLIDE);
        $row[] = $output->FormCheckbox('msie6slide', $jsm_settings['msie6slide']);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // MS IE 6 Shadow
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBMSIE6SHADOW);
        $row[] = $output->FormCheckbox('msie6shadow', $jsm_settings['msie6shadow']);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // MS IE 6 Opacity
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBMSIE6OPACITY);
        $row[] = $output->FormText('msie6opacity', isset( $jsm_settings['msie6opacity'])?$jsm_settings['msie6opacity']:100);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // Build on demand
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_JSMBBUILDONDEMAND);
        $row[] = $output->FormCheckbox('buildondemand', $jsm_settings['buildondemand']);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $rows[] = $row;

        // Add rows
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        foreach( $rows as $row ) {
            $output->TableAddRow($row, 'left');
        }
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Return output
        return $output->GetOutput();
    }

    function menublock_jsupdate( $blockinfo )
    {
        list( $jmbwidth, $lowbgcolor, $hibgcolor, $fontlowcolor, $fonthicolor,
              $bordercolor, $borderwidthmain, $borderwidthsub, $borderbtwmain, $borderbtwsub,
              $menumaxheight, $menumaxwidth,
              $fontfamily, $fontsize, $fontbold, $fontitalic,
              $menutextcentered, $menucentered, $menuvertcentered, $targetlocid,
              $starttop, $startleft, $vercorrect, $horcorrect, $toppadding, $leftpadding,
              $unfolddelay, $menuorient, $disappeardelay, $basehref,
              $unfoldonclick, $msie6slide, $msie6shadow, $msie6opacity, $buildondemand )
              = pnVarCleanFromInput(
                  'jmbwidth', 'lowbgcolor', 'hibgcolor', 'fontlowcolor', 'fonthicolor',
                  'bordercolor', 'borderwidthmain', 'borderwidthsub', 'borderbtwmain', 'borderbtwsub',
                  'menumaxheight', 'menumaxwidth',
                  'fontfamily', 'fontsize', 'fontbold', 'fontitalic',
                  'menutextcentered', 'menucentered', 'menuvertcentered', 'targetlocid',
                  'starttop', 'startleft', 'vercorrect', 'horcorrect', 'toppadding', 'leftpadding',
                  'unfolddelay', 'menuorient', 'disappeardelay', 'basehref',
                  'unfoldonclick', 'msie6slide', 'msie6shadow', 'msie6opacity', 'buildondemand');

        if( !isset( $jmbwidth )) { $jmbwidth = 10; }
        if( !isset( $borderwidthmain )) { $borderwidthmain = 0; }
        if( !isset( $borderwidthsub )) { $borderwidthsub = 0; }
        if( !isset( $borderbtwmain )) { $borderbtwmain = 0; }
        if( !isset( $borderbtwsub )) { $borderbtwsub = 0; }
        if( !isset( $fontbold )) { $fontbold = 0; }
        if( !isset( $fontitalic )) { $fontitalic = 0; }
        if( !isset( $starttop )) { $starttop = 0; }
        if( !isset( $startleft )) { $startleft = 0; }
        if( !isset( $vercorrect )) { $vercorrect = 0; }
        if( !isset( $horcorrect )) { $horcorrect = 0; }
        if( !isset( $toppadding )) { $toppadding = 0; }
        if( !isset( $leftpadding )) { $leftpadding = 0; }
        if( !isset( $unfolddelay )) { $unfolddelay = 100; }
        if( !isset( $menuorient )) { $menuorient = 0; }  // 1 - horizontal, 0 - vertical
        if( !isset( $disappeardelay )) { $disappeardelay = 1000; }
        if( !isset( $basehref )) { $basehref = ""; }
        if( !isset( $unfoldonclick )) { $unfoldonclick = 0; }
        if( !isset( $msie6slide )) { $msie6slide = false; }
        if( !isset( $msie6shadow )) { $msie6shadow = false; }
        if( !isset( $msie6opacity )) { $msie6opacity = 75; }
        if( !isset( $buildondemand )) { $buildondemand = 0; }

        // Color settings and others for javascript menu manipulated here.
        $jsm_settings = array(
                       'jmbwidth' => $jmbwidth,
                       'lowbgcolor' => $lowbgcolor,
                       'hibgcolor' => $hibgcolor,
                       'fontlowcolor' => $fontlowcolor,
                       'fonthicolor' => $fonthicolor,
                       'bordercolor' => $bordercolor,
                       'borderwidthmain' => $borderwidthmain,
                       'borderwidthsub' => $borderwidthsub,
                       'borderbtwmain' => $borderbtwmain,
                       'borderbtwsub' => $borderbtwsub,
                       'menumaxheight' => $menumaxheight,
                       'menumaxwidth' => $menumaxwidth,
                       'fontfamily' => $fontfamily,
                       'fontsize' => $fontsize,
                       'fontbold' => $fontbold,
                       'fontitalic' => $fontitalic,
                       'menutextcentered' => $menutextcentered,
                       'menucentered' => $menucentered,
                       'menuvertcentered' => $menuvertcentered,
                       'targetlocid' => $targetlocid,
                       'starttop' => $starttop,
                       'startleft' => $startleft,
                       'vercorrect' => $vercorrect,
                       'horcorrect' => $horcorrect,
                       'toppadding' => $toppadding,
                       'leftpadding' => $leftpadding,
                       'unfolddelay' => $unfolddelay,
                       'menuorient' => $menuorient,
                       'disappeardelay' => $disappeardelay,
                       'basehref' => $basehref,
                       'unfoldonclick' => $unfoldonclick,
                       'msie6slide' => $msie6slide,
                       'msie6shadow' => $msie6shadow,
                       'msie6opacity' => $msie6opacity,
                       'buildondemand' => $buildondemand );

        $cache = "modules/ContentExpress/pncache/jsmenu_par_$blockinfo[bid].js";

        if( file_exists( $cache )) {
            unlink( $cache );
        }

        if( $fh = @fopen( $cache, "w" )) {

             // Dump the settings from $jsm_settings
             fwrite( $fh, "var LowBgColor=\"$jsm_settings[lowbgcolor]\";\n" );
             fwrite( $fh, "var HighBgColor=\"$jsm_settings[hibgcolor]\";\n" );
             fwrite( $fh, "var FontLowColor=\"$jsm_settings[fontlowcolor]\";\n" );
             fwrite( $fh, "var FontHighColor=\"$jsm_settings[fonthicolor]\";\n" );
             fwrite( $fh, "var BorderColor=\"$jsm_settings[bordercolor]\";\n" );
             fwrite( $fh, "var BorderWidthMain=$jsm_settings[borderwidthmain];\n" );
             fwrite( $fh, "var BorderWidthSub=$jsm_settings[borderwidthsub];\n" );
             fwrite( $fh, "var BorderBtwnMain=$jsm_settings[borderbtwmain];\n" );
             fwrite( $fh, "var BorderBtwnSub=$jsm_settings[borderbtwsub];\n" );
             fwrite( $fh, "var FontFamily=\"$jsm_settings[fontfamily]\";\n" );
             fwrite( $fh, "var FontSize=$jsm_settings[fontsize];\n" );
             fwrite( $fh, "var FontBold=$jsm_settings[fontbold];\n" );
             fwrite( $fh, "var FontItalic=$jsm_settings[fontitalic];\n" );
             fwrite( $fh, "var MenuTextCentered=\"$jsm_settings[menutextcentered]\";\n" );
             fwrite( $fh, "var MenuCentered=\"$jsm_settings[menucentered]\";\n" );
             fwrite( $fh, "var MenuVerticalCentered=\"$jsm_settings[menuvertcentered]\";\n" );
             fwrite( $fh, "var ChildOverlap=.2;\n" );
             fwrite( $fh, "var ChildVerticalOverlap=.2;\n" );
             fwrite( $fh, "var StartTop=$jsm_settings[starttop];\n" );
             fwrite( $fh, "var StartLeft=$jsm_settings[startleft];\n" );
             fwrite( $fh, "var VerCorrect=$jsm_settings[vercorrect];\n" );
             fwrite( $fh, "var HorCorrect=$jsm_settings[horcorrect];\n" );
             fwrite( $fh, "var TopPaddng=$jsm_settings[toppadding];\n" );
             fwrite( $fh, "var LeftPaddng=$jsm_settings[leftpadding];\n" );
             fwrite( $fh, "var FirstLineHorizontal=$jsm_settings[menuorient];\n" );
             fwrite( $fh, "var MenuFramesVertical=0;\n" );
             fwrite( $fh, "var DissapearDelay=$jsm_settings[disappeardelay];\n" );
             fwrite( $fh, "var UnfoldDelay=$jsm_settings[unfolddelay];\n" );
             fwrite( $fh, "var TakeOverBgColor=1;\n" );
             fwrite( $fh, "var FirstLineFrame=\"\";\n" );
             fwrite( $fh, "var SecLineFrame=\"\";\n" );
             fwrite( $fh, "var DocTargetFrame=\"\";\n" );
             if( trim($jsm_settings['targetlocid']) == "" ) {
                 $jsm_settings['targetlocid'] = "jsmenu_$blockinfo[bid]";
             }
             fwrite( $fh, "var TargetLoc=\"$jsm_settings[targetlocid]\";\n" );
             fwrite( $fh, "var MenuWrap=1;\n" );
             fwrite( $fh, "var RightToLeft=0;\n" );
             fwrite( $fh, "var BottomUp=0;\n" );
             fwrite( $fh, "var UnfoldsOnClick=$jsm_settings[unfoldonclick];\n" );
             fwrite( $fh, "var BaseHref=\"$jsm_settings[basehref]\";\n" );
             fwrite( $fh, "var Arrws=['',5,10,'',5,10,'',5,10];\n" );
             fwrite( $fh, "var MenuUsesFrames=0;\n" );
             fwrite( $fh, "var RememberStatus=0;\n" );
             fwrite( $fh, "var PartOfWindow=.2;\n" );
             fwrite( $fh, "var BuildOnDemand=$jsm_settings[buildondemand];\n" );
             fwrite( $fh, "var MenuSlide=\"\";\n" );
             if( $jsm_settings['msie6slide'] ) {
                 fwrite( $fh, "var MenuSlide=\"progid:DXImageTransform.Microsoft.RevealTrans(duration=.5, transition=19)\";\n" );
                 fwrite( $fh, "var MenuSlide=\"progid:DXImageTransform.Microsoft.GradientWipe(duration=.5, wipeStyle=1)\";\n" );
             }
             fwrite( $fh, "var MenuShadow=\"\";\n" );
             if( $jsm_settings['msie6shadow'] ) {
                 fwrite( $fh, "var MenuShadow=\"progid:DXImageTransform.Microsoft.DropShadow(color=#888888, offX=2, offY=2, positive=1)\";\n" );
                 fwrite( $fh, "var MenuShadow=\"progid:DXImageTransform.Microsoft.Shadow(color=#888888, direction=135, strength=3)\";\n" );
             }
             fwrite( $fh, "var MenuOpacity=\"\";\n" );
             fwrite( $fh, "var MenuOpacity=\"progid:DXImageTransform.Microsoft.Alpha(opacity=$jsm_settings[msie6opacity])\";\n" );
     
             @fclose( $fh );
        }

        $cache = "modules/ContentExpress/pncache/jsmenu_$blockinfo[bid].js";

        if( file_exists( $cache )) {
            unlink( $cache );
        }

        $blockinfo['content'] = pnBlockVarsToContent($jsm_settings);
        return $blockinfo;
    }

    function menublock_jsdisplay( $blockinfo )
    {
        // Security check
        if (!pnSecAuthAction(0, "MenuExpress::Menublock",
                             "$blockinfo[title]::$blockinfo[bid]", ACCESS_READ)) {
            return;
        }

        // Check to see if the cache file exist, if so, include it,
        // TODO: Need to create function to retrieve gid of current user.
        // ISSUES: What if the user belongs to more than one group?
        // $cache = "modules/ContentExpress/pncache/jsmenu_$blockinfo[bid]_$gid.js";
        $param_cache = "modules/ContentExpress/pncache/jsmenu_par_$blockinfo[bid].js";
        $cache = "modules/ContentExpress/pncache/jsmenu_$blockinfo[bid].js";

        // Get current content
        $jsm_settings = pnBlockVarsFromContent($blockinfo['content']);
    
        if( !file_exists( $cache )) {
            $this->build_cache( $cache, $blockinfo, $jsm_settings );
        }

        $width = pnModGetVar('MenuExpress', 'jmbwidth')*$jsm_settings['menumaxwidth'];
        $height = pnModGetVar('MenuExpress', 'jmbheight')*$jsm_settings['menumaxheight'];
        $output = new pnHTML();
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text( "<SCRIPT TYPE=\"text/javascript\">function Go(){return}</SCRIPT>" );
        $output->Text( "<SCRIPT TYPE=\"text/javascript\" SRC=\"$param_cache\">" );
        $output->Text( "</SCRIPT>" );
        $output->Text( "<SCRIPT TYPE=\"text/javascript\" SRC=\"$cache\">" );
        $output->Text( "</SCRIPT>" );
        $output->Text( "<div id=\"$jsm_settings[targetlocid]\" style=\"position:relative; width:$width"."px; height:$height"."px \">" );
        $output->Text( "<img src=\"modules/ContentExpress/pnimages/blank.gif\" width=\"$width"."px\" height=\"$height"."px\">" );
        $output->Text( "</div>" );
        $output->SetInputMode(_PNH_PARSEINPUT);

        $blockinfo['content'] = $output->GetOutput();
        return themesideblock($blockinfo);
    }

    //--------------------------------------------------------------------------------------------------
    // Block helper function
    //--------------------------------------------------------------------------------------------------

    function build_cache( $cache, $blockinfo, $jsm_settings )
    {
        // Database information
        $output = new pnHTML();

        pnModDBInfoLoad('ContentExpress');

        // Load API.  Note that this is loading the user API, that is because the
        // user API contains the function to obtain item information which is the
        // first thing that we need to do.  If the API fails to load an appropriate
        // error message is posted and the function returns

        if (!pnModAPILoad('ContentExpress', 'user')) {
            $output->Text(_LOADFAILED.":ME:build_cache");
            return $output->GetOutput();
        }

        // The user API function is called.  This takes the item ID which we
        // obtained from the input and gets us the information on the appropriate
        // item.  If the item does not exist we post an appropriate message and
        // return
        $items = pnModAPIFunc('ContentExpress',
                              'user',
                              'getall_menuitems',
                              array( 'bid' => $blockinfo['bid'],
                                     'curr_date' => strftime( "%Y-%m-%d %H:%M:%S", time()),
                                     'curr_status' => 2 ));
        
        if ($items != false) {

            // Get the menu info
            $menus = array();
            foreach( $items as $item ) {
                if( $item['status'] == 2 ) {

                    $uri = $item['uri'];
                    if( preg_match( "/^http:\/\/.+/", $item['uri'], $matches ) > 0 ) {
                        // Parse to see if this is external web link, if so, don't mess with it
                        // Do nothing
                    } else if( preg_match( "/\[(.+)\](.*)/i", $item['uri'], $matches ) > 0 ) {
                        // Parse to see if there is any [<module>] syntax, if so, need to regenerate
                        // the URI for browser
                        $uri = "modules.php?op=modload&name=$matches[1]&file=index$matches[2]&meid=$item[id]";
                    } else if( preg_match( "/.+\?.+/", $item['uri'] ) > 0 ) {
                        // this is internal web link, parse to see if there is any argument attached
                        // already. if so, append meid to the end so the menu item "arrow" will
                        // display properly
                        $uri .= "&meid=$item[id]";
                    } else {
                        // otherwise append ? and the arguement only 
                        $uri .= "?meid=$item[id]";
                    }

                    $menus[(int)$item['id']] = array( 'name'       => $item['title'],
                                                      'url'        => $uri,
                                                      'parent'     => $item['parent_id'],
                                                      'weight'     => (float)$item['weight'],
                                                      'rollovera'  => $item['rollover_img1_file'],
                                                      'rolloverb'  => $item['rollover_img2_file'],
                                                      'newwindow'  => $item['newwindow'],
                                                      'background' => $item['bg_img_file'],
                                                      'child'      => array() );
                }
            }

            // Locate child menu items for each menu item
            $top_menus = 0;
            $tree = array();
            foreach( $menus as $id => $menuitem ) {
                $parent_id = $menuitem['parent'];
                if( $parent_id > 0 && !empty($menus[$parent_id])) {
                    // locates the parent and then updates its child list
                    array_push( $menus[$parent_id]['child'], $id );
                    $tree[$id] = $tree[$parent_id]."_".count( $menus[$parent_id]['child'] );
                } else {
                    $top_menus++;
                    $tree[$id] = $top_menus;
                }
            }

            if( $jsm_settings['menuorient'] == 0 ) { // Vertical
                pnModSetVar('MenuExpress', 'jmbheight', $top_menus);
                pnModSetVar('MenuExpress', 'jmbwidth', 1);
	    } else {                                 // Horizontal
                pnModSetVar('MenuExpress', 'jmbheight', 1);
                pnModSetVar('MenuExpress', 'jmbwidth', $top_menus);
	    }

            if( file_exists( $cache )) {
                unlink( $cache );
            }
            if( $fh = @fopen( $cache, "w" )) {

                fwrite( $fh, "var NoOffFirstLineMenus=$top_menus;\n" );

                $menu_images = array();
                // Dump the menu items from $menus
                foreach( $menus as $id => $menuitem ) {
                    if( strlen( trim( $menuitem['rollovera'] )) > 0 &&
                        strlen( trim( $menuitem['rolloverb'] )) > 0 ) {
                        if( strlen( trim( $menuitem['background'] )) > 0 ) {
                            fwrite( $fh, "Menu$tree[$id]=new Array(\"rollover?$menuitem[rollovera]?$menuitem[rolloverb]\",\"$menuitem[url]\",\"$menuitem[background]\",".count($menuitem[child]).", $jsm_settings[menumaxheight], $jsm_settings[menumaxwidth],\"\",\"\",\"\",\"\",\"\",\"\",-1,-1,-1,\"\",\"\",$menuitem[newwindow]);\n" );
                            $menu_images[] = $menuitem['background'];
                        } else {
                            fwrite( $fh, "Menu$tree[$id]=new Array(\"rollover?$menuitem[rollovera]?$menuitem[rolloverb]\",\"$menuitem[url]\",\"\",".count($menuitem[child]).", $jsm_settings[menumaxheight], $jsm_settings[menumaxwidth],\"\",\"\",\"\",\"\",\"\",\"\",-1,-1,-1,\"\",\"\",$menuitem[newwindow]);\n" );
                        }
                        $menu_images[] = $menuitem['rollovera'];
                        $menu_images[] = $menuitem['rolloverb'];
                    } else {
                        if( strlen( trim( $menuitem['background'] )) > 0 ) {
                            fwrite( $fh, "Menu$tree[$id]=new Array(\"$menuitem[name]\",\"$menuitem[url]\",\"$menuitem[background]\",".count($menuitem[child]).", $jsm_settings[menumaxheight], $jsm_settings[menumaxwidth],\"\",\"\",\"\",\"\",\"\",\"\",-1,-1,-1,\"\",\"\",$menuitem[newwindow]);\n" );
                            $menu_images[] = $menuitem['background'];
                        } else {
                            fwrite( $fh, "Menu$tree[$id]=new Array(\"$menuitem[name]\",\"$menuitem[url]\",\"\",".count($menuitem[child]).", $jsm_settings[menumaxheight], $jsm_settings[menumaxwidth],\"\",\"\",\"\",\"\",\"\",\"\",-1,-1,-1,\"\",\"\",$menuitem[newwindow]);\n" );
                        }
                    }
                }

                // Misc stuff
                fwrite( $fh, "function BeforeStart(){return}\n" );
                if( count( $menu_images ) > 0 && $jsm_settings['buildondemand'] ) {
                    fwrite( $fh, "function AfterBuild(){\n" );
                    fwrite( $fh, "    if( FrstCreat ) {\n" );
                    foreach( $menu_images as $id => $image ) {
                        fwrite( $fh, "    PreImg$id=new Image(); PreImg$id.src=\"$image\";\n" );
                    }
                    fwrite( $fh, "    }\n" );
                    fwrite( $fh, "}\n" );
                } else {
                    fwrite( $fh, "function AfterBuild(){return}\n" );
                }
                fwrite( $fh, "function BeforeFirstOpen(){return}\n" );
                fwrite( $fh, "function AfterCloseAll(){return}\n" );
                @fclose( $fh );
            }
        }

    }

    function build_menublock_tree( &$output, $blockinfo, $lists, $item, $curr_meid, $spacer = "" )
    {
        if (pnSecAuthAction(0, "MenuExpress::Menublock", "$blockinfo[title]:$item[name]:$item[id]", ACCESS_OVERVIEW) &&
            pnSecAuthAction(0, "MenuExpress::Menublock", "$blockinfo[bid]:$item[name]:$item[id]", ACCESS_OVERVIEW)) {
            if( !empty( $item )) {
                $menu = $item['title'];
                $child = $item['child'];
                $modinfo = pnModGetInfo(pnModGetIDFromName('ContentExpress'));
                $moddir = pnVarPrepForOS($modinfo['directory']);
                $mytheme = pnUserGetTheme();
                $blank = "<img width=\"8\" src=\"modules/$moddir/pnimages/blank.gif\">";
                if( file_exists( "themes/$mytheme/images/bullet.png" )) {
                    $bullet = "<img width=\"8\" src=\"themes/$mytheme/images/bullet.png\">";
                } else if( file_exists( "themes/$mytheme/images/bullet.jpg" )) {
                    $bullet = "<img width=\"8\" src=\"themes/$mytheme/images/bullet.jpg\">";
                } else if( file_exists( "themes/$mytheme/images/bullet.gif" )) {
                    $bullet = "<img width=\"8\" src=\"themes/$mytheme/images/bullet.gif\">";
                } else {
                    $bullet = $blank;
                }

                if( file_exists( "themes/$mytheme/images/arrow.png" )) {
                    $arrow = "<img width=\"8\" src=\"themes/$mytheme/images/arrow.png\">";
                } else if( file_exists( "themes/$mytheme/images/arrow.jpg" )) {
                    $arrow = "<img width=\"8\" src=\"themes/$mytheme/images/arrow.jpg\">";
                } else if( file_exists( "themes/$mytheme/images/arrow.gif" )) {
                    $arrow = "<img width=\"8\" src=\"themes/$mytheme/images/arrow.gif\">";
                } else {
                    $arrow = "<img width=\"8\" src=\"modules/$moddir/pnimages/right.gif\">";
                }
                if( $item['menutype'] == 3 || $item['menutype'] == 4 || $item['menutype'] == 5 ) {
                    if( pnModGetVar('MenuExpress', 'pnmenu_style') ) {
                        $menu = $spacer."<strong><big>&middot;</big></strong>&nbsp;".$menu;
                    } else {
                        if( $item['id'] == $curr_meid ) {
                            $menu = $spacer.$arrow.$menu;
                        } else {
                            $menu = $spacer.$bullet.$menu;
                        }
                    }
                } else if( $item['menutype'] == 2 ) {
                    if( pnModGetVar('MenuExpress', 'pnmenu_style') ) {
                        $menu = $spacer."<font class=\"pn-menuitem-title\">".$menu."</font>";
                    } else {
                        $menu = $spacer.$blank."<font class=\"pn-menuitem-title\">".$menu."</font>";
                    }
                }
                $spacer = $spacer.$blank;
                $output->SetOutputMode(_PNH_KEEPOUTPUT);
                $output->SetInputMode(_PNH_VERBATIMINPUT);
                if( pnSecAuthAction( 0, "MenuExpress::Menu", "$blockinfo[title]:$item[name]:$item[id]", ACCESS_EDIT ) ||
                    pnSecAuthAction( 0, "MenuExpress::Menu", "$blockinfo[bid]:$item[name]:$item[id]", ACCESS_EDIT )) {
                    if( pnModGetVar('MenuExpress', 'enable_qadmin') &&
                        !pnSecAuthAction( 0, "MenuExpress::", "::", ACCESS_ADMIN )) {
                        $output->SetOutputMode(_PNH_RETURNOUTPUT);
                        if( file_exists( "themes/$mytheme/images/edit.png" )) {
                            $admin = $output->URL( pnModURL( 'ContentExpress', 'admin', 'editcontent', array( 'ceid' => $ceid )), "<img class=\"icon\" border=\"0\" src=\"themes/$mytheme/images/edit.png\">", true );
                        }
                        else if( file_exists( "themes/$mytheme/images/edit.jpg" )) {
                            $admin = $output->URL( pnModURL( 'ContentExpress', 'admin', 'editcontent', array( 'ceid' => $ceid )), "<img class=\"icon\" border=\"0\" src=\"themes/$mytheme/images/edit.jpg\">", true );
                        }
                        else if( file_exists( "themes/$mytheme/images/edit.gif" )) {
                            $admin = $output->URL( pnModURL( 'ContentExpress', 'admin', 'editcontent', array( 'ceid' => $ceid )), "<img class=\"icon\" border=\"0\" src=\"themes/$mytheme/images/edit.gif\">", true );
                        }
                        else {
                            $admin = $output->Text( "[" );
                            $admin .= $output->URL( pnModURL( 'ContentExpress', 'admin', 'editmenu',
                                                        array( 'bid' => pnVarPrepForDisplay( $blockinfo['bid'] ),
                                                               'btitle' => pnVarPrepForDisplay( $blockinfo['title'] ),
                                                               'meid' => pnVarPrepForDisplay( $item['id'] ))),
                                                              _MENUCONTENTEDITMENU );
                            $admin .= $output->Text( "]" );
                        }
                        $output->SetOutputMode(_PNH_KEEPOUTPUT);
                        $output->Text($menu."&nbsp;".$admin);
                    } else {
                        $output->Text($menu);
                    }
                } else {
                    $output->Text($menu);
                }
                $output->Linebreak();
                $output->SetInputMode(_PNH_PARSEINPUT);
                if( count( $child ) > 0 ) {
                    foreach( $child as $cid ) {
                        $this->build_menublock_tree( $output, $blockinfo, $lists, $lists[$cid], $curr_meid, $spacer );
                    }
                }
            }
        }
    }

    function admin_menublock_select_form($title, $blocks, $item = 0) {
        $output = new pnCEHTML();

        $output->Title($title);

        // Block it belongs to
        $row = array();
    
        // parent list should be retreived from database
        $blks = array();
        $blks[] = array( 'id' => -1, 'selected' => 0, 'name' => _MENUCONTENTALLBLOCKS );
        if ( is_array($blocks) && count($blocks) > 0 ) {
            foreach( $blocks as $blk ) {
                $blks[] = array( 'id' => $blk['bid'], 'selected' => ($blk['bid']==$item['block_id'])?1:0, 'name' => $blk['title'] );
            }
        }
    
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        if( $item != 0 && !empty( $item )) {
            $row[] = $output->FormSelectMultiple('blk', $blks, 0, 1, $item['bid'],'','onChange="document.blockform.bid.value=this.options[this.selectedIndex].value; document.blockform.submit();"' );
        } else {
            $row[] = $output->FormSelectMultiple('blk', $blks, 0, 1, '', '', 'onChange="document.blockform.bid.value=this.options[this.selectedIndex].value;document.blockform.submit(); "');
        }
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->CEFormStart( pnModURL('ContentExpress', 'admin', "newmenu"), "blockform");
        $output->FormHidden( "bid" ); 
        $output->TableStart();
        $output->TableAddrow($row, 'center');
        $output->TableEnd();
        $output->CEFormEnd();
        $output->SetInputMode(_PNH_PARSEINPUT);

        return $output->GetOutput();
    }

}
?>
